/* ViewSelector.c generated by valac 0.42.2, the Vala compiler
 * generated from ViewSelector.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;
typedef struct _NoiseWidgetsViewSelectorPrivate NoiseWidgetsViewSelectorPrivate;

#define NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE (noise_widgets_view_selector_mode_get_type ())
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_0_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS
};
static guint noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS] = {0};

struct _NoiseWidgetsViewSelector {
	GtkToolItem parent_instance;
	NoiseWidgetsViewSelectorPrivate * priv;
};

struct _NoiseWidgetsViewSelectorClass {
	GtkToolItemClass parent_class;
};

typedef enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} NoiseWidgetsViewSelectorMode;

struct _NoiseWidgetsViewSelectorPrivate {
	GraniteWidgetsModeButton* mode_button;
	NoiseWidgetsViewSelectorMode mode;
};


static gint NoiseWidgetsViewSelector_private_offset;
static gpointer noise_widgets_view_selector_parent_class = NULL;

GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
GType noise_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelector* noise_widgets_view_selector_new (void);
NoiseWidgetsViewSelector* noise_widgets_view_selector_construct (GType object_type);
static void __lambda56_ (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                               NoiseWidgetsViewSelectorMode value);
static void ___lambda56__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                            GtkWidget* widget,
                                                            gpointer self);
gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                                   gboolean active);
NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self);
gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                                gboolean value);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS "action_view_albums"
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_LIST "action_view_list"
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS "action_view_columns"
static void noise_widgets_view_selector_finalize (GObject * obj);
static void _vala_noise_widgets_view_selector_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_widgets_view_selector_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static inline gpointer
noise_widgets_view_selector_get_instance_private (NoiseWidgetsViewSelector* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseWidgetsViewSelector_private_offset);
}


GType
noise_widgets_view_selector_mode_get_type (void)
{
	static volatile gsize noise_widgets_view_selector_mode_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID", "grid"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST", "list"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN", "column"}, {0, NULL, NULL}};
		GType noise_widgets_view_selector_mode_type_id;
		noise_widgets_view_selector_mode_type_id = g_enum_register_static ("NoiseWidgetsViewSelectorMode", values);
		g_once_init_leave (&noise_widgets_view_selector_mode_type_id__volatile, noise_widgets_view_selector_mode_type_id);
	}
	return noise_widgets_view_selector_mode_type_id__volatile;
}


static void
__lambda56_ (NoiseWidgetsViewSelector* self)
{
	gint new_mode = 0;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 93 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 93 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 93 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 93 "../src/Widgets/ViewSelector.vala"
	new_mode = _tmp2_;
#line 94 "../src/Widgets/ViewSelector.vala"
	_tmp3_ = new_mode;
#line 94 "../src/Widgets/ViewSelector.vala"
	if (_tmp3_ <= 2) {
#line 178 "ViewSelector.c"
		gint _tmp4_;
#line 95 "../src/Widgets/ViewSelector.vala"
		_tmp4_ = new_mode;
#line 95 "../src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, (NoiseWidgetsViewSelectorMode) _tmp4_);
#line 184 "ViewSelector.c"
	} else {
		GraniteWidgetsModeButton* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 96 "../src/Widgets/ViewSelector.vala"
		_tmp5_ = self->priv->mode_button;
#line 96 "../src/Widgets/ViewSelector.vala"
		_tmp6_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp5_);
#line 96 "../src/Widgets/ViewSelector.vala"
		_tmp7_ = _tmp6_;
#line 96 "../src/Widgets/ViewSelector.vala"
		if (_tmp7_) {
#line 197 "ViewSelector.c"
			NoiseWidgetsViewSelectorMode _tmp8_;
#line 97 "../src/Widgets/ViewSelector.vala"
			_tmp8_ = self->priv->mode;
#line 97 "../src/Widgets/ViewSelector.vala"
			noise_widgets_view_selector_set_selected (self, _tmp8_);
#line 203 "ViewSelector.c"
		}
	}
}


static void
___lambda56__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self)
{
#line 92 "../src/Widgets/ViewSelector.vala"
	__lambda56_ ((NoiseWidgetsViewSelector*) self);
#line 216 "ViewSelector.c"
}


NoiseWidgetsViewSelector*
noise_widgets_view_selector_construct (GType object_type)
{
	NoiseWidgetsViewSelector * self = NULL;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GtkImage* list = NULL;
	GtkImage* _tmp1_;
	GtkImage* column = NULL;
	GtkImage* _tmp2_;
	GraniteWidgetsModeButton* _tmp3_;
	GraniteWidgetsModeButton* _tmp4_;
	GraniteWidgetsModeButton* _tmp5_;
	GraniteWidgetsModeButton* _tmp6_;
	GraniteWidgetsModeButton* _tmp7_;
	GraniteWidgetsModeButton* _tmp8_;
#line 75 "../src/Widgets/ViewSelector.vala"
	self = (NoiseWidgetsViewSelector*) g_object_new (object_type, NULL);
#line 76 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 76 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp0_);
#line 76 "../src/Widgets/ViewSelector.vala"
	image = _tmp0_;
#line 77 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) image, _ ("View as Albums"));
#line 79 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 79 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp1_);
#line 79 "../src/Widgets/ViewSelector.vala"
	list = _tmp1_;
#line 80 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) list, _ ("View as List"));
#line 82 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("view-column-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 82 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp2_);
#line 82 "../src/Widgets/ViewSelector.vala"
	column = _tmp2_;
#line 83 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) column, _ ("View in Columns"));
#line 85 "../src/Widgets/ViewSelector.vala"
	_tmp3_ = granite_widgets_mode_button_new ();
#line 85 "../src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp3_);
#line 85 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 85 "../src/Widgets/ViewSelector.vala"
	self->priv->mode_button = _tmp3_;
#line 86 "../src/Widgets/ViewSelector.vala"
	_tmp4_ = self->priv->mode_button;
#line 86 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp4_, (GtkWidget*) image);
#line 87 "../src/Widgets/ViewSelector.vala"
	_tmp5_ = self->priv->mode_button;
#line 87 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp5_, (GtkWidget*) list);
#line 88 "../src/Widgets/ViewSelector.vala"
	_tmp6_ = self->priv->mode_button;
#line 88 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp6_, (GtkWidget*) column);
#line 90 "../src/Widgets/ViewSelector.vala"
	_tmp7_ = self->priv->mode_button;
#line 90 "../src/Widgets/ViewSelector.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 92 "../src/Widgets/ViewSelector.vala"
	_tmp8_ = self->priv->mode_button;
#line 92 "../src/Widgets/ViewSelector.vala"
	g_signal_connect_object (_tmp8_, "mode-changed", (GCallback) ___lambda56__granite_widgets_mode_button_mode_changed, self, 0);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (column);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (list);
#line 75 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (image);
#line 75 "../src/Widgets/ViewSelector.vala"
	return self;
#line 298 "ViewSelector.c"
}


NoiseWidgetsViewSelector*
noise_widgets_view_selector_new (void)
{
#line 75 "../src/Widgets/ViewSelector.vala"
	return noise_widgets_view_selector_construct (NOISE_WIDGETS_TYPE_VIEW_SELECTOR);
#line 307 "ViewSelector.c"
}


gboolean
noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self)
{
	gboolean result = FALSE;
	NoiseWidgetsViewSelectorMode _tmp0_;
#line 106 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode;
#line 107 "../src/Widgets/ViewSelector.vala"
	result = _tmp0_ == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 107 "../src/Widgets/ViewSelector.vala"
	return result;
#line 324 "ViewSelector.c"
}


void
noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                              gboolean active)
{
#line 110 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/Widgets/ViewSelector.vala"
	if (active) {
#line 112 "../src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
#line 338 "ViewSelector.c"
	} else {
#line 113 "../src/Widgets/ViewSelector.vala"
		if (noise_widgets_view_selector_get_column_browser_toggle_active (self)) {
#line 114 "../src/Widgets/ViewSelector.vala"
			noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST);
#line 344 "ViewSelector.c"
		}
	}
}


NoiseWidgetsViewSelectorMode
noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self)
{
	NoiseWidgetsViewSelectorMode result;
	NoiseWidgetsViewSelectorMode _tmp0_ = 0;
	NoiseWidgetsViewSelectorMode _tmp1_;
#line 40 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = self->priv->mode;
#line 41 "../src/Widgets/ViewSelector.vala"
	if (_tmp1_ != NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN) {
#line 362 "ViewSelector.c"
		NoiseWidgetsViewSelectorMode _tmp2_;
#line 41 "../src/Widgets/ViewSelector.vala"
		_tmp2_ = self->priv->mode;
#line 41 "../src/Widgets/ViewSelector.vala"
		_tmp0_ = _tmp2_;
#line 368 "ViewSelector.c"
	} else {
#line 41 "../src/Widgets/ViewSelector.vala"
		_tmp0_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 372 "ViewSelector.c"
	}
#line 41 "../src/Widgets/ViewSelector.vala"
	result = _tmp0_;
#line 41 "../src/Widgets/ViewSelector.vala"
	return result;
#line 378 "ViewSelector.c"
}


void
noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                          NoiseWidgetsViewSelectorMode value)
{
	NoiseWidgetsViewSelectorMode _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	gboolean is_column_mode = FALSE;
	gboolean _tmp2_;
	NoiseWidgetsViewSelectorMode _tmp3_ = 0;
	gboolean _tmp4_;
#line 43 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode;
#line 44 "../src/Widgets/ViewSelector.vala"
	if (_tmp0_ == value) {
#line 45 "../src/Widgets/ViewSelector.vala"
		return;
#line 400 "ViewSelector.c"
	}
#line 48 "../src/Widgets/ViewSelector.vala"
	self->priv->mode = value;
#line 49 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = self->priv->mode_button;
#line 49 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_selected (_tmp1_, (gint) value);
#line 51 "../src/Widgets/ViewSelector.vala"
	is_column_mode = value == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 52 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = is_column_mode;
#line 52 "../src/Widgets/ViewSelector.vala"
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL], 0, _tmp2_);
#line 53 "../src/Widgets/ViewSelector.vala"
	_tmp4_ = is_column_mode;
#line 53 "../src/Widgets/ViewSelector.vala"
	if (_tmp4_) {
#line 53 "../src/Widgets/ViewSelector.vala"
		_tmp3_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 420 "ViewSelector.c"
	} else {
#line 53 "../src/Widgets/ViewSelector.vala"
		_tmp3_ = value;
#line 424 "ViewSelector.c"
	}
#line 53 "../src/Widgets/ViewSelector.vala"
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL], 0, _tmp3_);
#line 43 "../src/Widgets/ViewSelector.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY]);
#line 430 "ViewSelector.c"
}


gboolean
noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self)
{
	gboolean result;
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 59 "../src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 60 "../src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/Widgets/ViewSelector.vala"
	result = _tmp2_;
#line 60 "../src/Widgets/ViewSelector.vala"
	return result;
#line 453 "ViewSelector.c"
}


void
noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                           gboolean value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_ = 0;
	GraniteWidgetsModeButton* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	NoiseLibraryWindow* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GAction* _tmp8_;
	NoiseLibraryWindow* _tmp9_;
	NoiseLibraryWindow* _tmp10_;
	GSimpleActionGroup* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GAction* _tmp13_;
	NoiseLibraryWindow* _tmp14_;
	NoiseLibraryWindow* _tmp15_;
	GSimpleActionGroup* _tmp16_;
	GSimpleActionGroup* _tmp17_;
	GAction* _tmp18_;
#line 62 "../src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 64 "../src/Widgets/ViewSelector.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, value);
#line 65 "../src/Widgets/ViewSelector.vala"
	if (value) {
#line 487 "ViewSelector.c"
		NoiseWidgetsViewSelectorMode _tmp2_;
#line 65 "../src/Widgets/ViewSelector.vala"
		_tmp2_ = self->priv->mode;
#line 65 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = (gint) _tmp2_;
#line 493 "ViewSelector.c"
	} else {
#line 65 "../src/Widgets/ViewSelector.vala"
		_tmp1_ = -1;
#line 497 "ViewSelector.c"
	}
#line 65 "../src/Widgets/ViewSelector.vala"
	_tmp3_ = self->priv->mode_button;
#line 65 "../src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_active (_tmp3_, _tmp1_);
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp4_ = noise_app_get_main_window ();
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp5_ = _tmp4_;
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp6_ = noise_library_window_get_actions (_tmp5_);
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp7_ = _tmp6_;
#line 66 "../src/Widgets/ViewSelector.vala"
	_tmp8_ = g_action_map_lookup_action ((GActionMap*) _tmp7_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
#line 66 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_simple_action_get_type (), GSimpleAction), value);
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp9_ = noise_app_get_main_window ();
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp10_ = _tmp9_;
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp11_ = noise_library_window_get_actions (_tmp10_);
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp12_ = _tmp11_;
#line 67 "../src/Widgets/ViewSelector.vala"
	_tmp13_ = g_action_map_lookup_action ((GActionMap*) _tmp12_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_LIST);
#line 67 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_simple_action_get_type (), GSimpleAction), value);
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp14_ = noise_app_get_main_window ();
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp15_ = _tmp14_;
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp16_ = noise_library_window_get_actions (_tmp15_);
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp17_ = _tmp16_;
#line 68 "../src/Widgets/ViewSelector.vala"
	_tmp18_ = g_action_map_lookup_action ((GActionMap*) _tmp17_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
#line 68 "../src/Widgets/ViewSelector.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_simple_action_get_type (), GSimpleAction), value);
#line 62 "../src/Widgets/ViewSelector.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY]);
#line 541 "ViewSelector.c"
}


static void
noise_widgets_view_selector_class_init (NoiseWidgetsViewSelectorClass * klass)
{
#line 27 "../src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Widgets/ViewSelector.vala"
	g_type_class_adjust_private_offset (klass, &NoiseWidgetsViewSelector_private_offset);
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_view_selector_get_property;
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_view_selector_set_property;
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_view_selector_finalize;
#line 27 "../src/Widgets/ViewSelector.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY] = g_param_spec_enum ("selected", "selected", "selected", NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/ViewSelector.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY] = g_param_spec_boolean ("sensitive", "sensitive", "sensitive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE);
#line 27 "../src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL] = g_signal_new ("column-browser-toggled", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 566 "ViewSelector.c"
}


static void
noise_widgets_view_selector_instance_init (NoiseWidgetsViewSelector * self)
{
#line 27 "../src/Widgets/ViewSelector.vala"
	self->priv = noise_widgets_view_selector_get_instance_private (self);
#line 575 "ViewSelector.c"
}


static void
noise_widgets_view_selector_finalize (GObject * obj)
{
	NoiseWidgetsViewSelector * self;
#line 27 "../src/Widgets/ViewSelector.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 72 "../src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 27 "../src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (noise_widgets_view_selector_parent_class)->finalize (obj);
#line 589 "ViewSelector.c"
}


GType
noise_widgets_view_selector_get_type (void)
{
	static volatile gsize noise_widgets_view_selector_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsViewSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_view_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsViewSelector), 0, (GInstanceInitFunc) noise_widgets_view_selector_instance_init, NULL };
		GType noise_widgets_view_selector_type_id;
		noise_widgets_view_selector_type_id = g_type_register_static (gtk_tool_item_get_type (), "NoiseWidgetsViewSelector", &g_define_type_info, 0);
		NoiseWidgetsViewSelector_private_offset = g_type_add_instance_private (noise_widgets_view_selector_type_id, sizeof (NoiseWidgetsViewSelectorPrivate));
		g_once_init_leave (&noise_widgets_view_selector_type_id__volatile, noise_widgets_view_selector_type_id);
	}
	return noise_widgets_view_selector_type_id__volatile;
}


static void
_vala_noise_widgets_view_selector_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 27 "../src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "../src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		g_value_set_enum (value, noise_widgets_view_selector_get_selected (self));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 27 "../src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		g_value_set_boolean (value, noise_widgets_view_selector_get_sensitive (self));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 630 "ViewSelector.c"
		default:
#line 27 "../src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 636 "ViewSelector.c"
	}
}


static void
_vala_noise_widgets_view_selector_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 27 "../src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "../src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, g_value_get_enum (value));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 27 "../src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
#line 27 "../src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_sensitive (self, g_value_get_boolean (value));
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 663 "ViewSelector.c"
		default:
#line 27 "../src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/ViewSelector.vala"
		break;
#line 669 "ViewSelector.c"
	}
}



