/* PlaybackManager.c generated by valac 0.42.2, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
enum  {
	NOISE_PLAYBACK_MANAGER_0_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	NoiseMedia* _current_media;
};

struct _Block10Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};


static gint NoisePlaybackManager_private_offset;
static gpointer noise_playback_manager_parent_class = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
void noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                          NoisePlayback* playback);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
void noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                           GeeCollection* to_unqueue);
static NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
static void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
static void noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                            NoiseMedia* m);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                             NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                              NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_get_next (NoisePlaybackManager* self,
                                             gboolean play);
static NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                               NoiseMedia* value);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
NoiseMedia* noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
void noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                        gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GSettings* noise_app_get_saved_state (void);
static gboolean __lambda33_ (Block10Data* _data10_);
static gboolean ___lambda33__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                         gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
noise_playback_manager_get_instance_private (NoisePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaybackManager_private_offset);
}


void
noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                     NoisePlayback* playback)
{
	GeeTreeSet* _tmp0_;
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (playback != NULL);
#line 117 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbacks;
#line 117 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
#line 251 "PlaybackManager.c"
}


void
noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	NoiseStaticPlaylist* _tmp9_;
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (to_queue != NULL);
#line 121 "../src/PlaybackManager.vala"
	_tmp0_ = gee_collection_get_size (to_queue);
#line 121 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 121 "../src/PlaybackManager.vala"
	if (_tmp1_ < 1) {
#line 122 "../src/PlaybackManager.vala"
		return;
#line 274 "PlaybackManager.c"
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
#line 125 "../src/PlaybackManager.vala"
		_q_it = _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 285 "PlaybackManager.c"
			GeeIterator* _tmp3_;
			NoiseMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 125 "../src/PlaybackManager.vala"
			_tmp3_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 125 "../src/PlaybackManager.vala"
				break;
#line 299 "PlaybackManager.c"
			}
#line 125 "../src/PlaybackManager.vala"
			_tmp4_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 125 "../src/PlaybackManager.vala"
			q = (NoiseMedia*) _tmp5_;
#line 126 "../src/PlaybackManager.vala"
			_tmp6_ = q;
#line 126 "../src/PlaybackManager.vala"
			_tmp7_ = noise_media_get_title (_tmp6_);
#line 126 "../src/PlaybackManager.vala"
			_tmp8_ = _tmp7_;
#line 126 "../src/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:126: QUEUED: %s", _tmp8_);
#line 125 "../src/PlaybackManager.vala"
			_g_object_unref0 (q);
#line 317 "PlaybackManager.c"
		}
#line 125 "../src/PlaybackManager.vala"
		_g_object_unref0 (_q_it);
#line 321 "PlaybackManager.c"
	}
#line 129 "../src/PlaybackManager.vala"
	_tmp9_ = self->queue_playlist;
#line 129 "../src/PlaybackManager.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _tmp9_, to_queue);
#line 327 "PlaybackManager.c"
}


void
noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	NoiseStaticPlaylist* _tmp0_;
#line 132 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/PlaybackManager.vala"
	g_return_if_fail (to_unqueue != NULL);
#line 133 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 133 "../src/PlaybackManager.vala"
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, to_unqueue);
#line 344 "PlaybackManager.c"
}


static NoiseMedia*
noise_playback_manager_poll_queue (NoisePlaybackManager* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* m = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	NoiseMedia* _tmp8_;
	GeeLinkedList* unqueued = NULL;
	GeeLinkedList* _tmp9_;
	NoiseStaticPlaylist* _tmp10_;
#line 136 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 137 "../src/PlaybackManager.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 137 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/PlaybackManager.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
#line 137 "../src/PlaybackManager.vala"
	m = (NoiseMedia*) _tmp3_;
#line 138 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 138 "../src/PlaybackManager.vala"
	_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp4_);
#line 138 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 138 "../src/PlaybackManager.vala"
	_tmp7_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp6_, 0);
#line 138 "../src/PlaybackManager.vala"
	_tmp8_ = (NoiseMedia*) _tmp7_;
#line 138 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp8_);
#line 139 "../src/PlaybackManager.vala"
	_tmp9_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 139 "../src/PlaybackManager.vala"
	unqueued = _tmp9_;
#line 140 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) unqueued, m);
#line 141 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 141 "../src/PlaybackManager.vala"
	g_signal_emit_by_name ((NoisePlaylist*) _tmp10_, "media-removed", (GeeCollection*) unqueued);
#line 142 "../src/PlaybackManager.vala"
	result = m;
#line 142 "../src/PlaybackManager.vala"
	_g_object_unref0 (unqueued);
#line 142 "../src/PlaybackManager.vala"
	return result;
#line 405 "PlaybackManager.c"
}


void
noise_playback_manager_clear_queue (NoisePlaybackManager* self)
{
	GeeHashMap* _tmp0_;
#line 145 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 146 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 147 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_index (self, 0);
#line 149 "../src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 423 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                 gint index_in_current)
{
	NoiseMedia* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 152 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 153 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 153 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 153 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 153 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 153 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 453 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
#line 154 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current;
#line 154 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) index_in_current));
#line 154 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp6_;
#line 154 "../src/PlaybackManager.vala"
		return result;
#line 464 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp7_;
		gpointer _tmp8_;
#line 156 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_current_shuffled;
#line 156 "../src/PlaybackManager.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) index_in_current));
#line 156 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp8_;
#line 156 "../src/PlaybackManager.vala"
		return result;
#line 476 "PlaybackManager.c"
	}
}


GeeCollection*
noise_playback_manager_get_current_media_list (NoisePlaybackManager* self)
{
	GeeCollection* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 160 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 161 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 161 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 161 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 161 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 161 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 506 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 162 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_shuffled;
#line 162 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 162 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 162 "../src/PlaybackManager.vala"
		result = _tmp7_;
#line 162 "../src/PlaybackManager.vala"
		return result;
#line 520 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 164 "../src/PlaybackManager.vala"
		_tmp8_ = self->priv->_current;
#line 164 "../src/PlaybackManager.vala"
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
#line 164 "../src/PlaybackManager.vala"
		_tmp10_ = _tmp9_;
#line 164 "../src/PlaybackManager.vala"
		result = _tmp10_;
#line 164 "../src/PlaybackManager.vala"
		return result;
#line 535 "PlaybackManager.c"
	}
}


static void
noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                       NoiseMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 168 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 169 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 169 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 169 "../src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 169 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 169 "../src/PlaybackManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
#line 562 "PlaybackManager.c"
}


void
noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                        NoiseSettingsRepeat mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
#line 172 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 173 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 174 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 174 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
#line 174 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 589 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 175 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 175 "../src/PlaybackManager.vala"
		noise_settings_main_set_repeat_mode (_tmp4_, mode);
#line 595 "PlaybackManager.c"
	}
#line 172 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 599 "PlaybackManager.c"
}


void
noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                         NoiseSettingsShuffle mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
#line 179 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 180 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 181 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 181 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 181 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 181 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 626 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 182 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 182 "../src/PlaybackManager.vala"
		noise_settings_main_set_shuffle_mode (_tmp4_, mode);
#line 183 "../src/PlaybackManager.vala"
		noise_playback_manager_reshuffle (self);
#line 634 "PlaybackManager.c"
	}
#line 179 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 638 "PlaybackManager.c"
}


/**
    * Regenerate the shuffled queue if needed
    */
static void
noise_playback_manager_reshuffle (NoisePlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
#line 190 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:191: Reshuffling");
#line 192 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 192 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 193 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled_index = 0;
#line 195 "../src/PlaybackManager.vala"
	_tmp1_ = noise_settings_main_get_default ();
#line 195 "../src/PlaybackManager.vala"
	main_settings = _tmp1_;
#line 196 "../src/PlaybackManager.vala"
	_tmp2_ = main_settings;
#line 196 "../src/PlaybackManager.vala"
	_tmp3_ = noise_settings_main_get_shuffle_mode (_tmp2_);
#line 196 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 196 "../src/PlaybackManager.vala"
	if (_tmp4_ == NOISE_SETTINGS_SHUFFLE_OFF) {
#line 676 "PlaybackManager.c"
		NoiseMedia* _tmp5_;
#line 197 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_media;
#line 197 "../src/PlaybackManager.vala"
		if (_tmp5_ != NULL) {
#line 682 "PlaybackManager.c"
			{
				gint i = 0;
#line 199 "../src/PlaybackManager.vala"
				i = 0;
#line 687 "PlaybackManager.c"
				{
					gboolean _tmp6_ = FALSE;
#line 199 "../src/PlaybackManager.vala"
					_tmp6_ = TRUE;
#line 199 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 694 "PlaybackManager.c"
						gint _tmp8_;
						GeeHashMap* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
						GeeHashMap* _tmp12_;
						gint _tmp13_;
						gpointer _tmp14_;
						NoiseMedia* _tmp15_;
						NoiseMedia* _tmp16_;
						gboolean _tmp17_;
#line 199 "../src/PlaybackManager.vala"
						if (!_tmp6_) {
#line 707 "PlaybackManager.c"
							gint _tmp7_;
#line 199 "../src/PlaybackManager.vala"
							_tmp7_ = i;
#line 199 "../src/PlaybackManager.vala"
							i = _tmp7_ + 1;
#line 713 "PlaybackManager.c"
						}
#line 199 "../src/PlaybackManager.vala"
						_tmp6_ = FALSE;
#line 199 "../src/PlaybackManager.vala"
						_tmp8_ = i;
#line 199 "../src/PlaybackManager.vala"
						_tmp9_ = self->priv->_current;
#line 199 "../src/PlaybackManager.vala"
						_tmp10_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp9_);
#line 199 "../src/PlaybackManager.vala"
						_tmp11_ = _tmp10_;
#line 199 "../src/PlaybackManager.vala"
						if (!(_tmp8_ < _tmp11_)) {
#line 199 "../src/PlaybackManager.vala"
							break;
#line 729 "PlaybackManager.c"
						}
#line 200 "../src/PlaybackManager.vala"
						_tmp12_ = self->priv->_current;
#line 200 "../src/PlaybackManager.vala"
						_tmp13_ = i;
#line 200 "../src/PlaybackManager.vala"
						_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) _tmp13_));
#line 200 "../src/PlaybackManager.vala"
						_tmp15_ = (NoiseMedia*) _tmp14_;
#line 200 "../src/PlaybackManager.vala"
						_tmp16_ = self->priv->_current_media;
#line 200 "../src/PlaybackManager.vala"
						_tmp17_ = _tmp15_ == _tmp16_;
#line 200 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp15_);
#line 200 "../src/PlaybackManager.vala"
						if (_tmp17_) {
#line 747 "PlaybackManager.c"
							gint _tmp18_;
#line 201 "../src/PlaybackManager.vala"
							_tmp18_ = i;
#line 201 "../src/PlaybackManager.vala"
							self->priv->_current_index = _tmp18_;
#line 202 "../src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 202 "../src/PlaybackManager.vala"
							return;
#line 757 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
#line 206 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 765 "PlaybackManager.c"
		}
	} else {
		NoiseSettingsMain* _tmp19_;
		NoiseSettingsShuffle _tmp20_;
		NoiseSettingsShuffle _tmp21_;
#line 208 "../src/PlaybackManager.vala"
		_tmp19_ = main_settings;
#line 208 "../src/PlaybackManager.vala"
		_tmp20_ = noise_settings_main_get_shuffle_mode (_tmp19_);
#line 208 "../src/PlaybackManager.vala"
		_tmp21_ = _tmp20_;
#line 208 "../src/PlaybackManager.vala"
		if (_tmp21_ == NOISE_SETTINGS_SHUFFLE_ALL) {
#line 779 "PlaybackManager.c"
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp22_;
#line 210 "../src/PlaybackManager.vala"
			_tmp22_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 210 "../src/PlaybackManager.vala"
			temp = _tmp22_;
#line 786 "PlaybackManager.c"
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp23_;
				GeeCollection* _tmp24_;
				GeeCollection* _tmp25_;
				GeeCollection* _tmp26_;
				GeeIterator* _tmp27_;
				GeeIterator* _tmp28_;
#line 211 "../src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current;
#line 211 "../src/PlaybackManager.vala"
				_tmp24_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp23_);
#line 211 "../src/PlaybackManager.vala"
				_tmp25_ = _tmp24_;
#line 211 "../src/PlaybackManager.vala"
				_tmp26_ = _tmp25_;
#line 211 "../src/PlaybackManager.vala"
				_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 211 "../src/PlaybackManager.vala"
				_tmp28_ = _tmp27_;
#line 211 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp26_);
#line 211 "../src/PlaybackManager.vala"
				_m_it = _tmp28_;
#line 211 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 813 "PlaybackManager.c"
					GeeIterator* _tmp29_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp30_;
					gpointer _tmp31_;
					GeeLinkedList* _tmp32_;
					NoiseMedia* _tmp33_;
#line 211 "../src/PlaybackManager.vala"
					_tmp29_ = _m_it;
#line 211 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp29_)) {
#line 211 "../src/PlaybackManager.vala"
						break;
#line 826 "PlaybackManager.c"
					}
#line 211 "../src/PlaybackManager.vala"
					_tmp30_ = _m_it;
#line 211 "../src/PlaybackManager.vala"
					_tmp31_ = gee_iterator_get (_tmp30_);
#line 211 "../src/PlaybackManager.vala"
					m = (NoiseMedia*) _tmp31_;
#line 212 "../src/PlaybackManager.vala"
					_tmp32_ = temp;
#line 212 "../src/PlaybackManager.vala"
					_tmp33_ = m;
#line 212 "../src/PlaybackManager.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 211 "../src/PlaybackManager.vala"
					_g_object_unref0 (m);
#line 842 "PlaybackManager.c"
				}
#line 211 "../src/PlaybackManager.vala"
				_g_object_unref0 (_m_it);
#line 846 "PlaybackManager.c"
			}
			{
				gint i = 0;
#line 218 "../src/PlaybackManager.vala"
				i = 1;
#line 852 "PlaybackManager.c"
				{
					gboolean _tmp34_ = FALSE;
#line 218 "../src/PlaybackManager.vala"
					_tmp34_ = TRUE;
#line 218 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 859 "PlaybackManager.c"
						gint _tmp36_;
						GeeHashMap* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						gint n_media = 0;
						GeeLinkedList* _tmp40_;
						gint _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						gint _tmp44_ = 0;
						gint _tmp45_;
						gint random = 0;
						gboolean _tmp47_ = FALSE;
						NoiseMedia* _tmp48_;
						GeeLinkedList* _tmp63_;
						GeeLinkedList* _tmp64_;
						gint _tmp65_;
						gpointer _tmp66_;
						NoiseMedia* _tmp67_;
#line 218 "../src/PlaybackManager.vala"
						if (!_tmp34_) {
#line 881 "PlaybackManager.c"
							gint _tmp35_;
#line 218 "../src/PlaybackManager.vala"
							_tmp35_ = i;
#line 218 "../src/PlaybackManager.vala"
							i = _tmp35_ + 1;
#line 887 "PlaybackManager.c"
						}
#line 218 "../src/PlaybackManager.vala"
						_tmp34_ = FALSE;
#line 218 "../src/PlaybackManager.vala"
						_tmp36_ = i;
#line 218 "../src/PlaybackManager.vala"
						_tmp37_ = self->priv->_current;
#line 218 "../src/PlaybackManager.vala"
						_tmp38_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp37_);
#line 218 "../src/PlaybackManager.vala"
						_tmp39_ = _tmp38_;
#line 218 "../src/PlaybackManager.vala"
						if (!(_tmp36_ < _tmp39_)) {
#line 218 "../src/PlaybackManager.vala"
							break;
#line 903 "PlaybackManager.c"
						}
#line 219 "../src/PlaybackManager.vala"
						_tmp40_ = temp;
#line 219 "../src/PlaybackManager.vala"
						_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
#line 219 "../src/PlaybackManager.vala"
						_tmp42_ = _tmp41_;
#line 219 "../src/PlaybackManager.vala"
						n_media = _tmp42_;
#line 220 "../src/PlaybackManager.vala"
						_tmp43_ = n_media;
#line 220 "../src/PlaybackManager.vala"
						if (_tmp43_ == 0) {
#line 221 "../src/PlaybackManager.vala"
							break;
#line 919 "PlaybackManager.c"
						}
#line 224 "../src/PlaybackManager.vala"
						_tmp45_ = n_media;
#line 224 "../src/PlaybackManager.vala"
						if (_tmp45_ <= 1) {
#line 224 "../src/PlaybackManager.vala"
							_tmp44_ = 0;
#line 927 "PlaybackManager.c"
						} else {
							gint _tmp46_;
#line 224 "../src/PlaybackManager.vala"
							_tmp46_ = n_media;
#line 224 "../src/PlaybackManager.vala"
							_tmp44_ = (gint) g_random_int_range ((gint32) 0, (gint32) (_tmp46_ - 1));
#line 934 "PlaybackManager.c"
						}
#line 224 "../src/PlaybackManager.vala"
						random = _tmp44_;
#line 226 "../src/PlaybackManager.vala"
						_tmp48_ = self->priv->_current_media;
#line 226 "../src/PlaybackManager.vala"
						if (_tmp48_ != NULL) {
#line 942 "PlaybackManager.c"
							GeeLinkedList* _tmp49_;
							gint _tmp50_;
							gpointer _tmp51_;
							NoiseMedia* _tmp52_;
							NoiseMedia* _tmp53_;
#line 226 "../src/PlaybackManager.vala"
							_tmp49_ = temp;
#line 226 "../src/PlaybackManager.vala"
							_tmp50_ = random;
#line 226 "../src/PlaybackManager.vala"
							_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp49_, _tmp50_);
#line 226 "../src/PlaybackManager.vala"
							_tmp52_ = (NoiseMedia*) _tmp51_;
#line 226 "../src/PlaybackManager.vala"
							_tmp53_ = self->priv->_current_media;
#line 226 "../src/PlaybackManager.vala"
							_tmp47_ = _tmp52_ == _tmp53_;
#line 226 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp52_);
#line 962 "PlaybackManager.c"
						} else {
#line 226 "../src/PlaybackManager.vala"
							_tmp47_ = FALSE;
#line 966 "PlaybackManager.c"
						}
#line 226 "../src/PlaybackManager.vala"
						if (_tmp47_) {
#line 970 "PlaybackManager.c"
							GeeHashMap* _tmp54_;
							NoiseMedia* _tmp55_;
							gint _tmp56_;
#line 227 "../src/PlaybackManager.vala"
							_tmp54_ = self->priv->_current_shuffled;
#line 227 "../src/PlaybackManager.vala"
							_tmp55_ = self->priv->_current_media;
#line 227 "../src/PlaybackManager.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, (gpointer) ((gintptr) 0), _tmp55_);
#line 228 "../src/PlaybackManager.vala"
							_tmp56_ = i;
#line 228 "../src/PlaybackManager.vala"
							i = _tmp56_ - 1;
#line 984 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp57_;
							gint _tmp58_;
							GeeLinkedList* _tmp59_;
							gint _tmp60_;
							gpointer _tmp61_;
							NoiseMedia* _tmp62_;
#line 230 "../src/PlaybackManager.vala"
							_tmp57_ = self->priv->_current_shuffled;
#line 230 "../src/PlaybackManager.vala"
							_tmp58_ = i;
#line 230 "../src/PlaybackManager.vala"
							_tmp59_ = temp;
#line 230 "../src/PlaybackManager.vala"
							_tmp60_ = random;
#line 230 "../src/PlaybackManager.vala"
							_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp59_, _tmp60_);
#line 230 "../src/PlaybackManager.vala"
							_tmp62_ = (NoiseMedia*) _tmp61_;
#line 230 "../src/PlaybackManager.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp57_, (gpointer) ((gintptr) _tmp58_), _tmp62_);
#line 230 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp62_);
#line 1008 "PlaybackManager.c"
						}
#line 232 "../src/PlaybackManager.vala"
						_tmp63_ = temp;
#line 232 "../src/PlaybackManager.vala"
						_tmp64_ = temp;
#line 232 "../src/PlaybackManager.vala"
						_tmp65_ = random;
#line 232 "../src/PlaybackManager.vala"
						_tmp66_ = gee_abstract_list_get ((GeeAbstractList*) _tmp64_, _tmp65_);
#line 232 "../src/PlaybackManager.vala"
						_tmp67_ = (NoiseMedia*) _tmp66_;
#line 232 "../src/PlaybackManager.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp63_, _tmp67_);
#line 232 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp67_);
#line 1024 "PlaybackManager.c"
					}
				}
			}
#line 208 "../src/PlaybackManager.vala"
			_g_object_unref0 (temp);
#line 1030 "PlaybackManager.c"
		}
	}
#line 190 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 1035 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_next (NoisePlaybackManager* self,
                                 gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 237 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../src/PlaybackManager.vala"
	rv = NULL;
#line 240 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 240 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 242 "../src/PlaybackManager.vala"
	_tmp1_ = self->queue_playlist;
#line 242 "../src/PlaybackManager.vala"
	_tmp2_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp1_);
#line 242 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 242 "../src/PlaybackManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 242 "../src/PlaybackManager.vala"
	_tmp5_ = _tmp4_;
#line 242 "../src/PlaybackManager.vala"
	if (_tmp5_ > 0) {
#line 1072 "PlaybackManager.c"
		NoiseMedia* _tmp6_;
#line 243 "../src/PlaybackManager.vala"
		_tmp6_ = noise_playback_manager_poll_queue (self);
#line 243 "../src/PlaybackManager.vala"
		_g_object_unref0 (rv);
#line 243 "../src/PlaybackManager.vala"
		rv = _tmp6_;
#line 244 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 1082 "PlaybackManager.c"
	} else {
		NoiseSettingsMain* _tmp7_;
		NoiseSettingsShuffle _tmp8_;
		NoiseSettingsShuffle _tmp9_;
#line 245 "../src/PlaybackManager.vala"
		_tmp7_ = main_settings;
#line 245 "../src/PlaybackManager.vala"
		_tmp8_ = noise_settings_main_get_shuffle_mode (_tmp7_);
#line 245 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 245 "../src/PlaybackManager.vala"
		if (_tmp9_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 1095 "PlaybackManager.c"
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			NoiseMedia* _tmp23_;
#line 246 "../src/PlaybackManager.vala"
			_tmp10_ = self->priv->_current_shuffled;
#line 246 "../src/PlaybackManager.vala"
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
#line 246 "../src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 246 "../src/PlaybackManager.vala"
			if (_tmp12_) {
#line 1108 "PlaybackManager.c"
				{
					GeeIterator* _s_it = NULL;
					NoiseLibrary* _tmp13_;
					NoiseLibrary* _tmp14_;
					GeeCollection* _tmp15_;
					GeeCollection* _tmp16_;
					GeeIterator* _tmp17_;
					GeeIterator* _tmp18_;
#line 247 "../src/PlaybackManager.vala"
					_tmp13_ = noise_playback_manager_get_library (self);
#line 247 "../src/PlaybackManager.vala"
					_tmp14_ = _tmp13_;
#line 247 "../src/PlaybackManager.vala"
					_tmp15_ = noise_library_get_medias (_tmp14_);
#line 247 "../src/PlaybackManager.vala"
					_tmp16_ = _tmp15_;
#line 247 "../src/PlaybackManager.vala"
					_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 247 "../src/PlaybackManager.vala"
					_tmp18_ = _tmp17_;
#line 247 "../src/PlaybackManager.vala"
					_g_object_unref0 (_tmp16_);
#line 247 "../src/PlaybackManager.vala"
					_s_it = _tmp18_;
#line 247 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 1135 "PlaybackManager.c"
						GeeIterator* _tmp19_;
						NoiseMedia* s = NULL;
						GeeIterator* _tmp20_;
						gpointer _tmp21_;
						NoiseMedia* _tmp22_;
#line 247 "../src/PlaybackManager.vala"
						_tmp19_ = _s_it;
#line 247 "../src/PlaybackManager.vala"
						if (!gee_iterator_next (_tmp19_)) {
#line 247 "../src/PlaybackManager.vala"
							break;
#line 1147 "PlaybackManager.c"
						}
#line 247 "../src/PlaybackManager.vala"
						_tmp20_ = _s_it;
#line 247 "../src/PlaybackManager.vala"
						_tmp21_ = gee_iterator_get (_tmp20_);
#line 247 "../src/PlaybackManager.vala"
						s = (NoiseMedia*) _tmp21_;
#line 248 "../src/PlaybackManager.vala"
						_tmp22_ = s;
#line 248 "../src/PlaybackManager.vala"
						noise_playback_manager_add_to_current (self, _tmp22_);
#line 247 "../src/PlaybackManager.vala"
						_g_object_unref0 (s);
#line 1161 "PlaybackManager.c"
					}
#line 247 "../src/PlaybackManager.vala"
					_g_object_unref0 (_s_it);
#line 1165 "PlaybackManager.c"
				}
#line 249 "../src/PlaybackManager.vala"
				noise_playback_manager_reshuffle (self);
#line 1169 "PlaybackManager.c"
			}
#line 251 "../src/PlaybackManager.vala"
			self->priv->_playing_queued_song = FALSE;
#line 253 "../src/PlaybackManager.vala"
			_tmp23_ = self->priv->_current_media;
#line 253 "../src/PlaybackManager.vala"
			if (_tmp23_ == NULL) {
#line 1177 "PlaybackManager.c"
				GeeHashMap* _tmp24_;
				gpointer _tmp25_;
#line 254 "../src/PlaybackManager.vala"
				self->priv->_current_shuffled_index = 0;
#line 255 "../src/PlaybackManager.vala"
				_tmp24_ = self->priv->_current_shuffled;
#line 255 "../src/PlaybackManager.vala"
				_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) 0));
#line 255 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 255 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp25_;
#line 1190 "PlaybackManager.c"
			} else {
				NoiseSettingsMain* _tmp26_;
				NoiseSettingsRepeat _tmp27_;
				NoiseSettingsRepeat _tmp28_;
#line 256 "../src/PlaybackManager.vala"
				_tmp26_ = main_settings;
#line 256 "../src/PlaybackManager.vala"
				_tmp27_ = noise_settings_main_get_repeat_mode (_tmp26_);
#line 256 "../src/PlaybackManager.vala"
				_tmp28_ = _tmp27_;
#line 256 "../src/PlaybackManager.vala"
				if (_tmp28_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1203 "PlaybackManager.c"
					GeeHashMap* _tmp29_;
					gint _tmp30_;
					gpointer _tmp31_;
#line 257 "../src/PlaybackManager.vala"
					_tmp29_ = self->priv->_current_shuffled;
#line 257 "../src/PlaybackManager.vala"
					_tmp30_ = self->priv->_current_shuffled_index;
#line 257 "../src/PlaybackManager.vala"
					_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, (gpointer) ((gintptr) _tmp30_));
#line 257 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 257 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp31_;
#line 1217 "PlaybackManager.c"
				} else {
					gint _tmp32_;
					GeeHashMap* _tmp33_;
					gint _tmp34_;
					gint _tmp35_;
#line 258 "../src/PlaybackManager.vala"
					_tmp32_ = self->priv->_current_shuffled_index;
#line 258 "../src/PlaybackManager.vala"
					_tmp33_ = self->priv->_current_shuffled;
#line 258 "../src/PlaybackManager.vala"
					_tmp34_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp33_);
#line 258 "../src/PlaybackManager.vala"
					_tmp35_ = _tmp34_;
#line 258 "../src/PlaybackManager.vala"
					if (_tmp32_ == (_tmp35_ - 1)) {
#line 1233 "PlaybackManager.c"
						NoiseSettingsMain* _tmp36_;
						NoiseSettingsRepeat _tmp37_;
						NoiseSettingsRepeat _tmp38_;
						GeeHashMap* _tmp41_;
						gpointer _tmp42_;
#line 259 "../src/PlaybackManager.vala"
						_tmp36_ = main_settings;
#line 259 "../src/PlaybackManager.vala"
						_tmp37_ = noise_settings_main_get_repeat_mode (_tmp36_);
#line 259 "../src/PlaybackManager.vala"
						_tmp38_ = _tmp37_;
#line 259 "../src/PlaybackManager.vala"
						if (_tmp38_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 260 "../src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 1249 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp39_;
							GeeHashMap* _tmp40_;
#line 263 "../src/PlaybackManager.vala"
							noise_playback_manager_set_current_media (self, NULL);
#line 264 "../src/PlaybackManager.vala"
							_tmp39_ = self->priv->_current_shuffled;
#line 264 "../src/PlaybackManager.vala"
							gee_abstract_map_clear ((GeeAbstractMap*) _tmp39_);
#line 265 "../src/PlaybackManager.vala"
							_tmp40_ = self->priv->_current;
#line 265 "../src/PlaybackManager.vala"
							gee_abstract_map_clear ((GeeAbstractMap*) _tmp40_);
#line 266 "../src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 267 "../src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 269 "../src/PlaybackManager.vala"
							if (play) {
#line 270 "../src/PlaybackManager.vala"
								noise_playback_manager_stop_playback (self);
#line 1271 "PlaybackManager.c"
							}
#line 273 "../src/PlaybackManager.vala"
							result = NULL;
#line 273 "../src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 273 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 273 "../src/PlaybackManager.vala"
							return result;
#line 1281 "PlaybackManager.c"
						}
#line 276 "../src/PlaybackManager.vala"
						_tmp41_ = self->priv->_current_shuffled;
#line 276 "../src/PlaybackManager.vala"
						_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) 0));
#line 276 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 276 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp42_;
#line 1291 "PlaybackManager.c"
					} else {
						gboolean _tmp43_ = FALSE;
						gint _tmp44_;
#line 277 "../src/PlaybackManager.vala"
						_tmp44_ = self->priv->_current_shuffled_index;
#line 277 "../src/PlaybackManager.vala"
						if (_tmp44_ >= 0) {
#line 1299 "PlaybackManager.c"
							gint _tmp45_;
							GeeHashMap* _tmp46_;
							gint _tmp47_;
							gint _tmp48_;
#line 277 "../src/PlaybackManager.vala"
							_tmp45_ = self->priv->_current_shuffled_index;
#line 277 "../src/PlaybackManager.vala"
							_tmp46_ = self->priv->_current_shuffled;
#line 277 "../src/PlaybackManager.vala"
							_tmp47_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp46_);
#line 277 "../src/PlaybackManager.vala"
							_tmp48_ = _tmp47_;
#line 277 "../src/PlaybackManager.vala"
							_tmp43_ = _tmp45_ < (_tmp48_ - 1);
#line 1314 "PlaybackManager.c"
						} else {
#line 277 "../src/PlaybackManager.vala"
							_tmp43_ = FALSE;
#line 1318 "PlaybackManager.c"
						}
#line 277 "../src/PlaybackManager.vala"
						if (_tmp43_) {
#line 1322 "PlaybackManager.c"
							NoiseMedia* next_current = NULL;
							GeeHashMap* _tmp49_;
							gint _tmp50_;
							gpointer _tmp51_;
							NoiseMedia* now_current = NULL;
							GeeHashMap* _tmp52_;
							gint _tmp53_;
							gpointer _tmp54_;
							gboolean _tmp55_ = FALSE;
							NoiseSettingsMain* _tmp56_;
							NoiseSettingsRepeat _tmp57_;
							NoiseSettingsRepeat _tmp58_;
							GeeHashMap* _tmp98_;
							gint _tmp99_;
							gpointer _tmp100_;
#line 279 "../src/PlaybackManager.vala"
							_tmp49_ = self->priv->_current_shuffled;
#line 279 "../src/PlaybackManager.vala"
							_tmp50_ = self->priv->_current_shuffled_index;
#line 279 "../src/PlaybackManager.vala"
							_tmp51_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp49_, (gpointer) ((gintptr) (_tmp50_ + 1)));
#line 279 "../src/PlaybackManager.vala"
							next_current = (NoiseMedia*) _tmp51_;
#line 280 "../src/PlaybackManager.vala"
							_tmp52_ = self->priv->_current_shuffled;
#line 280 "../src/PlaybackManager.vala"
							_tmp53_ = self->priv->_current_shuffled_index;
#line 280 "../src/PlaybackManager.vala"
							_tmp54_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp52_, (gpointer) ((gintptr) _tmp53_));
#line 280 "../src/PlaybackManager.vala"
							now_current = (NoiseMedia*) _tmp54_;
#line 282 "../src/PlaybackManager.vala"
							_tmp56_ = main_settings;
#line 282 "../src/PlaybackManager.vala"
							_tmp57_ = noise_settings_main_get_repeat_mode (_tmp56_);
#line 282 "../src/PlaybackManager.vala"
							_tmp58_ = _tmp57_;
#line 282 "../src/PlaybackManager.vala"
							if (_tmp58_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1362 "PlaybackManager.c"
								NoiseMedia* _tmp59_;
								const gchar* _tmp60_;
								const gchar* _tmp61_;
								NoiseMedia* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
#line 282 "../src/PlaybackManager.vala"
								_tmp59_ = next_current;
#line 282 "../src/PlaybackManager.vala"
								_tmp60_ = noise_media_get_artist (_tmp59_);
#line 282 "../src/PlaybackManager.vala"
								_tmp61_ = _tmp60_;
#line 282 "../src/PlaybackManager.vala"
								_tmp62_ = now_current;
#line 282 "../src/PlaybackManager.vala"
								_tmp63_ = noise_media_get_artist (_tmp62_);
#line 282 "../src/PlaybackManager.vala"
								_tmp64_ = _tmp63_;
#line 282 "../src/PlaybackManager.vala"
								_tmp55_ = g_strcmp0 (_tmp61_, _tmp64_) != 0;
#line 1383 "PlaybackManager.c"
							} else {
#line 282 "../src/PlaybackManager.vala"
								_tmp55_ = FALSE;
#line 1387 "PlaybackManager.c"
							}
#line 282 "../src/PlaybackManager.vala"
							if (_tmp55_) {
#line 283 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1393 "PlaybackManager.c"
									GeeHashMap* _tmp65_;
									gint _tmp66_;
									gpointer _tmp67_;
									NoiseMedia* _tmp68_;
									const gchar* _tmp69_;
									const gchar* _tmp70_;
									NoiseMedia* _tmp71_;
									const gchar* _tmp72_;
									const gchar* _tmp73_;
									gboolean _tmp74_;
									gint _tmp75_;
#line 283 "../src/PlaybackManager.vala"
									_tmp65_ = self->priv->_current_shuffled;
#line 283 "../src/PlaybackManager.vala"
									_tmp66_ = self->priv->_current_shuffled_index;
#line 283 "../src/PlaybackManager.vala"
									_tmp67_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp65_, (gpointer) ((gintptr) (_tmp66_ - 1)));
#line 283 "../src/PlaybackManager.vala"
									_tmp68_ = (NoiseMedia*) _tmp67_;
#line 283 "../src/PlaybackManager.vala"
									_tmp69_ = noise_media_get_artist (_tmp68_);
#line 283 "../src/PlaybackManager.vala"
									_tmp70_ = _tmp69_;
#line 283 "../src/PlaybackManager.vala"
									_tmp71_ = self->priv->_current_media;
#line 283 "../src/PlaybackManager.vala"
									_tmp72_ = noise_media_get_artist (_tmp71_);
#line 283 "../src/PlaybackManager.vala"
									_tmp73_ = _tmp72_;
#line 283 "../src/PlaybackManager.vala"
									_tmp74_ = !(g_strcmp0 (_tmp70_, _tmp73_) == 0);
#line 283 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp68_);
#line 283 "../src/PlaybackManager.vala"
									if (_tmp74_) {
#line 283 "../src/PlaybackManager.vala"
										break;
#line 1431 "PlaybackManager.c"
									}
#line 284 "../src/PlaybackManager.vala"
									_tmp75_ = self->priv->_current_shuffled_index;
#line 284 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp75_ - 1;
#line 1437 "PlaybackManager.c"
								}
							} else {
								gboolean _tmp76_ = FALSE;
								NoiseSettingsMain* _tmp77_;
								NoiseSettingsRepeat _tmp78_;
								NoiseSettingsRepeat _tmp79_;
#line 286 "../src/PlaybackManager.vala"
								_tmp77_ = main_settings;
#line 286 "../src/PlaybackManager.vala"
								_tmp78_ = noise_settings_main_get_repeat_mode (_tmp77_);
#line 286 "../src/PlaybackManager.vala"
								_tmp79_ = _tmp78_;
#line 286 "../src/PlaybackManager.vala"
								if (_tmp79_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1452 "PlaybackManager.c"
									NoiseMedia* _tmp80_;
									const gchar* _tmp81_;
									const gchar* _tmp82_;
									NoiseMedia* _tmp83_;
									const gchar* _tmp84_;
									const gchar* _tmp85_;
#line 286 "../src/PlaybackManager.vala"
									_tmp80_ = next_current;
#line 286 "../src/PlaybackManager.vala"
									_tmp81_ = noise_media_get_album (_tmp80_);
#line 286 "../src/PlaybackManager.vala"
									_tmp82_ = _tmp81_;
#line 286 "../src/PlaybackManager.vala"
									_tmp83_ = now_current;
#line 286 "../src/PlaybackManager.vala"
									_tmp84_ = noise_media_get_album (_tmp83_);
#line 286 "../src/PlaybackManager.vala"
									_tmp85_ = _tmp84_;
#line 286 "../src/PlaybackManager.vala"
									_tmp76_ = g_strcmp0 (_tmp82_, _tmp85_) != 0;
#line 1473 "PlaybackManager.c"
								} else {
#line 286 "../src/PlaybackManager.vala"
									_tmp76_ = FALSE;
#line 1477 "PlaybackManager.c"
								}
#line 286 "../src/PlaybackManager.vala"
								if (_tmp76_) {
#line 287 "../src/PlaybackManager.vala"
									while (TRUE) {
#line 1483 "PlaybackManager.c"
										GeeHashMap* _tmp86_;
										gint _tmp87_;
										gpointer _tmp88_;
										NoiseMedia* _tmp89_;
										const gchar* _tmp90_;
										const gchar* _tmp91_;
										NoiseMedia* _tmp92_;
										const gchar* _tmp93_;
										const gchar* _tmp94_;
										gboolean _tmp95_;
										gint _tmp96_;
#line 287 "../src/PlaybackManager.vala"
										_tmp86_ = self->priv->_current_shuffled;
#line 287 "../src/PlaybackManager.vala"
										_tmp87_ = self->priv->_current_shuffled_index;
#line 287 "../src/PlaybackManager.vala"
										_tmp88_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp86_, (gpointer) ((gintptr) (_tmp87_ - 1)));
#line 287 "../src/PlaybackManager.vala"
										_tmp89_ = (NoiseMedia*) _tmp88_;
#line 287 "../src/PlaybackManager.vala"
										_tmp90_ = noise_media_get_album (_tmp89_);
#line 287 "../src/PlaybackManager.vala"
										_tmp91_ = _tmp90_;
#line 287 "../src/PlaybackManager.vala"
										_tmp92_ = self->priv->_current_media;
#line 287 "../src/PlaybackManager.vala"
										_tmp93_ = noise_media_get_album (_tmp92_);
#line 287 "../src/PlaybackManager.vala"
										_tmp94_ = _tmp93_;
#line 287 "../src/PlaybackManager.vala"
										_tmp95_ = !(g_strcmp0 (_tmp91_, _tmp94_) == 0);
#line 287 "../src/PlaybackManager.vala"
										_g_object_unref0 (_tmp89_);
#line 287 "../src/PlaybackManager.vala"
										if (_tmp95_) {
#line 287 "../src/PlaybackManager.vala"
											break;
#line 1521 "PlaybackManager.c"
										}
#line 288 "../src/PlaybackManager.vala"
										_tmp96_ = self->priv->_current_shuffled_index;
#line 288 "../src/PlaybackManager.vala"
										self->priv->_current_shuffled_index = _tmp96_ - 1;
#line 1527 "PlaybackManager.c"
									}
								} else {
									gint _tmp97_;
#line 291 "../src/PlaybackManager.vala"
									_tmp97_ = self->priv->_current_shuffled_index;
#line 291 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp97_ + 1;
#line 1535 "PlaybackManager.c"
								}
							}
#line 294 "../src/PlaybackManager.vala"
							_tmp98_ = self->priv->_current_shuffled;
#line 294 "../src/PlaybackManager.vala"
							_tmp99_ = self->priv->_current_shuffled_index;
#line 294 "../src/PlaybackManager.vala"
							_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp98_, (gpointer) ((gintptr) _tmp99_));
#line 294 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 294 "../src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp100_;
#line 277 "../src/PlaybackManager.vala"
							_g_object_unref0 (now_current);
#line 277 "../src/PlaybackManager.vala"
							_g_object_unref0 (next_current);
#line 1552 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp101_;
							gpointer _tmp102_;
#line 296 "../src/PlaybackManager.vala"
							self->priv->_current_shuffled_index = 0;
#line 297 "../src/PlaybackManager.vala"
							noise_playback_manager_set_shuffle_mode (self, NOISE_SETTINGS_SHUFFLE_ALL);
#line 298 "../src/PlaybackManager.vala"
							_tmp101_ = self->priv->_current_shuffled;
#line 298 "../src/PlaybackManager.vala"
							_tmp102_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp101_, (gpointer) ((gintptr) 0));
#line 298 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 298 "../src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp102_;
#line 1568 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
			NoiseMedia* _tmp103_;
#line 301 "../src/PlaybackManager.vala"
			self->priv->_playing_queued_song = FALSE;
#line 303 "../src/PlaybackManager.vala"
			_tmp103_ = self->priv->_current_media;
#line 303 "../src/PlaybackManager.vala"
			if (_tmp103_ == NULL) {
#line 1581 "PlaybackManager.c"
				GeeHashMap* _tmp104_;
				gpointer _tmp105_;
#line 304 "../src/PlaybackManager.vala"
				self->priv->_current_index = 0;
#line 305 "../src/PlaybackManager.vala"
				_tmp104_ = self->priv->_current;
#line 305 "../src/PlaybackManager.vala"
				_tmp105_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp104_, (gpointer) ((gintptr) 0));
#line 305 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 305 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp105_;
#line 1594 "PlaybackManager.c"
			} else {
				NoiseSettingsMain* _tmp106_;
				NoiseSettingsRepeat _tmp107_;
				NoiseSettingsRepeat _tmp108_;
#line 306 "../src/PlaybackManager.vala"
				_tmp106_ = main_settings;
#line 306 "../src/PlaybackManager.vala"
				_tmp107_ = noise_settings_main_get_repeat_mode (_tmp106_);
#line 306 "../src/PlaybackManager.vala"
				_tmp108_ = _tmp107_;
#line 306 "../src/PlaybackManager.vala"
				if (_tmp108_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1607 "PlaybackManager.c"
					GeeHashMap* _tmp109_;
					gint _tmp110_;
					gpointer _tmp111_;
#line 307 "../src/PlaybackManager.vala"
					_tmp109_ = self->priv->_current;
#line 307 "../src/PlaybackManager.vala"
					_tmp110_ = self->priv->_current_index;
#line 307 "../src/PlaybackManager.vala"
					_tmp111_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp109_, (gpointer) ((gintptr) _tmp110_));
#line 307 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 307 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp111_;
#line 1621 "PlaybackManager.c"
				} else {
					gint _tmp112_;
					GeeHashMap* _tmp113_;
					gint _tmp114_;
					gint _tmp115_;
#line 308 "../src/PlaybackManager.vala"
					_tmp112_ = self->priv->_current_index;
#line 308 "../src/PlaybackManager.vala"
					_tmp113_ = self->priv->_current;
#line 308 "../src/PlaybackManager.vala"
					_tmp114_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp113_);
#line 308 "../src/PlaybackManager.vala"
					_tmp115_ = _tmp114_;
#line 308 "../src/PlaybackManager.vala"
					if (_tmp112_ == (_tmp115_ - 1)) {
#line 1637 "PlaybackManager.c"
						NoiseSettingsMain* _tmp116_;
						NoiseSettingsRepeat _tmp117_;
						NoiseSettingsRepeat _tmp118_;
						GeeHashMap* _tmp119_;
						gpointer _tmp120_;
#line 309 "../src/PlaybackManager.vala"
						_tmp116_ = main_settings;
#line 309 "../src/PlaybackManager.vala"
						_tmp117_ = noise_settings_main_get_repeat_mode (_tmp116_);
#line 309 "../src/PlaybackManager.vala"
						_tmp118_ = _tmp117_;
#line 309 "../src/PlaybackManager.vala"
						if (_tmp118_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 310 "../src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 1653 "PlaybackManager.c"
						} else {
#line 312 "../src/PlaybackManager.vala"
							if (play) {
#line 313 "../src/PlaybackManager.vala"
								noise_playback_manager_stop_playback (self);
#line 1659 "PlaybackManager.c"
							}
#line 315 "../src/PlaybackManager.vala"
							result = NULL;
#line 315 "../src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 315 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 315 "../src/PlaybackManager.vala"
							return result;
#line 1669 "PlaybackManager.c"
						}
#line 318 "../src/PlaybackManager.vala"
						_tmp119_ = self->priv->_current;
#line 318 "../src/PlaybackManager.vala"
						_tmp120_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp119_, (gpointer) ((gintptr) 0));
#line 318 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 318 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp120_;
#line 1679 "PlaybackManager.c"
					} else {
						gboolean _tmp121_ = FALSE;
						gint _tmp122_;
#line 319 "../src/PlaybackManager.vala"
						_tmp122_ = self->priv->_current_index;
#line 319 "../src/PlaybackManager.vala"
						if (_tmp122_ >= 0) {
#line 1687 "PlaybackManager.c"
							gint _tmp123_;
							GeeHashMap* _tmp124_;
							gint _tmp125_;
							gint _tmp126_;
#line 319 "../src/PlaybackManager.vala"
							_tmp123_ = self->priv->_current_index;
#line 319 "../src/PlaybackManager.vala"
							_tmp124_ = self->priv->_current;
#line 319 "../src/PlaybackManager.vala"
							_tmp125_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp124_);
#line 319 "../src/PlaybackManager.vala"
							_tmp126_ = _tmp125_;
#line 319 "../src/PlaybackManager.vala"
							_tmp121_ = _tmp123_ < (_tmp126_ - 1);
#line 1702 "PlaybackManager.c"
						} else {
#line 319 "../src/PlaybackManager.vala"
							_tmp121_ = FALSE;
#line 1706 "PlaybackManager.c"
						}
#line 319 "../src/PlaybackManager.vala"
						if (_tmp121_) {
#line 1710 "PlaybackManager.c"
							NoiseMedia* next_current = NULL;
							GeeHashMap* _tmp127_;
							gint _tmp128_;
							gpointer _tmp129_;
							NoiseMedia* now_current = NULL;
							GeeHashMap* _tmp130_;
							gint _tmp131_;
							gpointer _tmp132_;
							gboolean _tmp133_ = FALSE;
							NoiseSettingsMain* _tmp134_;
							NoiseSettingsRepeat _tmp135_;
							NoiseSettingsRepeat _tmp136_;
							GeeHashMap* _tmp176_;
							gint _tmp177_;
							gpointer _tmp178_;
#line 321 "../src/PlaybackManager.vala"
							_tmp127_ = self->priv->_current;
#line 321 "../src/PlaybackManager.vala"
							_tmp128_ = self->priv->_current_index;
#line 321 "../src/PlaybackManager.vala"
							_tmp129_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp127_, (gpointer) ((gintptr) (_tmp128_ + 1)));
#line 321 "../src/PlaybackManager.vala"
							next_current = (NoiseMedia*) _tmp129_;
#line 322 "../src/PlaybackManager.vala"
							_tmp130_ = self->priv->_current;
#line 322 "../src/PlaybackManager.vala"
							_tmp131_ = self->priv->_current_index;
#line 322 "../src/PlaybackManager.vala"
							_tmp132_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp130_, (gpointer) ((gintptr) _tmp131_));
#line 322 "../src/PlaybackManager.vala"
							now_current = (NoiseMedia*) _tmp132_;
#line 324 "../src/PlaybackManager.vala"
							_tmp134_ = main_settings;
#line 324 "../src/PlaybackManager.vala"
							_tmp135_ = noise_settings_main_get_repeat_mode (_tmp134_);
#line 324 "../src/PlaybackManager.vala"
							_tmp136_ = _tmp135_;
#line 324 "../src/PlaybackManager.vala"
							if (_tmp136_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1750 "PlaybackManager.c"
								NoiseMedia* _tmp137_;
								const gchar* _tmp138_;
								const gchar* _tmp139_;
								NoiseMedia* _tmp140_;
								const gchar* _tmp141_;
								const gchar* _tmp142_;
#line 324 "../src/PlaybackManager.vala"
								_tmp137_ = next_current;
#line 324 "../src/PlaybackManager.vala"
								_tmp138_ = noise_media_get_artist (_tmp137_);
#line 324 "../src/PlaybackManager.vala"
								_tmp139_ = _tmp138_;
#line 324 "../src/PlaybackManager.vala"
								_tmp140_ = now_current;
#line 324 "../src/PlaybackManager.vala"
								_tmp141_ = noise_media_get_artist (_tmp140_);
#line 324 "../src/PlaybackManager.vala"
								_tmp142_ = _tmp141_;
#line 324 "../src/PlaybackManager.vala"
								_tmp133_ = g_strcmp0 (_tmp139_, _tmp142_) != 0;
#line 1771 "PlaybackManager.c"
							} else {
#line 324 "../src/PlaybackManager.vala"
								_tmp133_ = FALSE;
#line 1775 "PlaybackManager.c"
							}
#line 324 "../src/PlaybackManager.vala"
							if (_tmp133_) {
#line 325 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1781 "PlaybackManager.c"
									GeeHashMap* _tmp143_;
									gint _tmp144_;
									gpointer _tmp145_;
									NoiseMedia* _tmp146_;
									const gchar* _tmp147_;
									const gchar* _tmp148_;
									NoiseMedia* _tmp149_;
									const gchar* _tmp150_;
									const gchar* _tmp151_;
									gboolean _tmp152_;
									gint _tmp153_;
#line 325 "../src/PlaybackManager.vala"
									_tmp143_ = self->priv->_current;
#line 325 "../src/PlaybackManager.vala"
									_tmp144_ = self->priv->_current_index;
#line 325 "../src/PlaybackManager.vala"
									_tmp145_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp143_, (gpointer) ((gintptr) (_tmp144_ - 1)));
#line 325 "../src/PlaybackManager.vala"
									_tmp146_ = (NoiseMedia*) _tmp145_;
#line 325 "../src/PlaybackManager.vala"
									_tmp147_ = noise_media_get_artist (_tmp146_);
#line 325 "../src/PlaybackManager.vala"
									_tmp148_ = _tmp147_;
#line 325 "../src/PlaybackManager.vala"
									_tmp149_ = self->priv->_current_media;
#line 325 "../src/PlaybackManager.vala"
									_tmp150_ = noise_media_get_artist (_tmp149_);
#line 325 "../src/PlaybackManager.vala"
									_tmp151_ = _tmp150_;
#line 325 "../src/PlaybackManager.vala"
									_tmp152_ = !(g_strcmp0 (_tmp148_, _tmp151_) == 0);
#line 325 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp146_);
#line 325 "../src/PlaybackManager.vala"
									if (_tmp152_) {
#line 325 "../src/PlaybackManager.vala"
										break;
#line 1819 "PlaybackManager.c"
									}
#line 326 "../src/PlaybackManager.vala"
									_tmp153_ = self->priv->_current_index;
#line 326 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp153_ - 1;
#line 1825 "PlaybackManager.c"
								}
							} else {
								gboolean _tmp154_ = FALSE;
								NoiseSettingsMain* _tmp155_;
								NoiseSettingsRepeat _tmp156_;
								NoiseSettingsRepeat _tmp157_;
#line 328 "../src/PlaybackManager.vala"
								_tmp155_ = main_settings;
#line 328 "../src/PlaybackManager.vala"
								_tmp156_ = noise_settings_main_get_repeat_mode (_tmp155_);
#line 328 "../src/PlaybackManager.vala"
								_tmp157_ = _tmp156_;
#line 328 "../src/PlaybackManager.vala"
								if (_tmp157_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1840 "PlaybackManager.c"
									NoiseMedia* _tmp158_;
									const gchar* _tmp159_;
									const gchar* _tmp160_;
									NoiseMedia* _tmp161_;
									const gchar* _tmp162_;
									const gchar* _tmp163_;
#line 328 "../src/PlaybackManager.vala"
									_tmp158_ = next_current;
#line 328 "../src/PlaybackManager.vala"
									_tmp159_ = noise_media_get_album (_tmp158_);
#line 328 "../src/PlaybackManager.vala"
									_tmp160_ = _tmp159_;
#line 328 "../src/PlaybackManager.vala"
									_tmp161_ = now_current;
#line 328 "../src/PlaybackManager.vala"
									_tmp162_ = noise_media_get_album (_tmp161_);
#line 328 "../src/PlaybackManager.vala"
									_tmp163_ = _tmp162_;
#line 328 "../src/PlaybackManager.vala"
									_tmp154_ = g_strcmp0 (_tmp160_, _tmp163_) != 0;
#line 1861 "PlaybackManager.c"
								} else {
#line 328 "../src/PlaybackManager.vala"
									_tmp154_ = FALSE;
#line 1865 "PlaybackManager.c"
								}
#line 328 "../src/PlaybackManager.vala"
								if (_tmp154_) {
#line 329 "../src/PlaybackManager.vala"
									while (TRUE) {
#line 1871 "PlaybackManager.c"
										GeeHashMap* _tmp164_;
										gint _tmp165_;
										gpointer _tmp166_;
										NoiseMedia* _tmp167_;
										const gchar* _tmp168_;
										const gchar* _tmp169_;
										NoiseMedia* _tmp170_;
										const gchar* _tmp171_;
										const gchar* _tmp172_;
										gboolean _tmp173_;
										gint _tmp174_;
#line 329 "../src/PlaybackManager.vala"
										_tmp164_ = self->priv->_current;
#line 329 "../src/PlaybackManager.vala"
										_tmp165_ = self->priv->_current_index;
#line 329 "../src/PlaybackManager.vala"
										_tmp166_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp164_, (gpointer) ((gintptr) (_tmp165_ - 1)));
#line 329 "../src/PlaybackManager.vala"
										_tmp167_ = (NoiseMedia*) _tmp166_;
#line 329 "../src/PlaybackManager.vala"
										_tmp168_ = noise_media_get_album (_tmp167_);
#line 329 "../src/PlaybackManager.vala"
										_tmp169_ = _tmp168_;
#line 329 "../src/PlaybackManager.vala"
										_tmp170_ = self->priv->_current_media;
#line 329 "../src/PlaybackManager.vala"
										_tmp171_ = noise_media_get_album (_tmp170_);
#line 329 "../src/PlaybackManager.vala"
										_tmp172_ = _tmp171_;
#line 329 "../src/PlaybackManager.vala"
										_tmp173_ = !(g_strcmp0 (_tmp169_, _tmp172_) == 0);
#line 329 "../src/PlaybackManager.vala"
										_g_object_unref0 (_tmp167_);
#line 329 "../src/PlaybackManager.vala"
										if (_tmp173_) {
#line 329 "../src/PlaybackManager.vala"
											break;
#line 1909 "PlaybackManager.c"
										}
#line 330 "../src/PlaybackManager.vala"
										_tmp174_ = self->priv->_current_index;
#line 330 "../src/PlaybackManager.vala"
										self->priv->_current_index = _tmp174_ - 1;
#line 1915 "PlaybackManager.c"
									}
								} else {
									gint _tmp175_;
#line 333 "../src/PlaybackManager.vala"
									_tmp175_ = self->priv->_current_index;
#line 333 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp175_ + 1;
#line 1923 "PlaybackManager.c"
								}
							}
#line 336 "../src/PlaybackManager.vala"
							_tmp176_ = self->priv->_current;
#line 336 "../src/PlaybackManager.vala"
							_tmp177_ = self->priv->_current_index;
#line 336 "../src/PlaybackManager.vala"
							_tmp178_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp176_, (gpointer) ((gintptr) _tmp177_));
#line 336 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 336 "../src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp178_;
#line 319 "../src/PlaybackManager.vala"
							_g_object_unref0 (now_current);
#line 319 "../src/PlaybackManager.vala"
							_g_object_unref0 (next_current);
#line 1940 "PlaybackManager.c"
						} else {
							GeeHashMap* _tmp189_;
							gpointer _tmp190_;
							{
								GeeIterator* _s_it = NULL;
								NoiseLibrary* _tmp179_;
								NoiseLibrary* _tmp180_;
								GeeCollection* _tmp181_;
								GeeCollection* _tmp182_;
								GeeIterator* _tmp183_;
								GeeIterator* _tmp184_;
#line 338 "../src/PlaybackManager.vala"
								_tmp179_ = noise_playback_manager_get_library (self);
#line 338 "../src/PlaybackManager.vala"
								_tmp180_ = _tmp179_;
#line 338 "../src/PlaybackManager.vala"
								_tmp181_ = noise_library_get_medias (_tmp180_);
#line 338 "../src/PlaybackManager.vala"
								_tmp182_ = _tmp181_;
#line 338 "../src/PlaybackManager.vala"
								_tmp183_ = gee_iterable_iterator ((GeeIterable*) _tmp182_);
#line 338 "../src/PlaybackManager.vala"
								_tmp184_ = _tmp183_;
#line 338 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp182_);
#line 338 "../src/PlaybackManager.vala"
								_s_it = _tmp184_;
#line 338 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1970 "PlaybackManager.c"
									GeeIterator* _tmp185_;
									NoiseMedia* s = NULL;
									GeeIterator* _tmp186_;
									gpointer _tmp187_;
									NoiseMedia* _tmp188_;
#line 338 "../src/PlaybackManager.vala"
									_tmp185_ = _s_it;
#line 338 "../src/PlaybackManager.vala"
									if (!gee_iterator_next (_tmp185_)) {
#line 338 "../src/PlaybackManager.vala"
										break;
#line 1982 "PlaybackManager.c"
									}
#line 338 "../src/PlaybackManager.vala"
									_tmp186_ = _s_it;
#line 338 "../src/PlaybackManager.vala"
									_tmp187_ = gee_iterator_get (_tmp186_);
#line 338 "../src/PlaybackManager.vala"
									s = (NoiseMedia*) _tmp187_;
#line 339 "../src/PlaybackManager.vala"
									_tmp188_ = s;
#line 339 "../src/PlaybackManager.vala"
									noise_playback_manager_add_to_current (self, _tmp188_);
#line 338 "../src/PlaybackManager.vala"
									_g_object_unref0 (s);
#line 1996 "PlaybackManager.c"
								}
#line 338 "../src/PlaybackManager.vala"
								_g_object_unref0 (_s_it);
#line 2000 "PlaybackManager.c"
							}
#line 342 "../src/PlaybackManager.vala"
							self->priv->_current_index = 0;
#line 343 "../src/PlaybackManager.vala"
							_tmp189_ = self->priv->_current;
#line 343 "../src/PlaybackManager.vala"
							_tmp190_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp189_, (gpointer) ((gintptr) 0));
#line 343 "../src/PlaybackManager.vala"
							_g_object_unref0 (rv);
#line 343 "../src/PlaybackManager.vala"
							rv = (NoiseMedia*) _tmp190_;
#line 2012 "PlaybackManager.c"
						}
					}
				}
			}
		}
	}
#line 347 "../src/PlaybackManager.vala"
	if (play) {
#line 2021 "PlaybackManager.c"
		NoiseMedia* _tmp191_;
#line 348 "../src/PlaybackManager.vala"
		_tmp191_ = rv;
#line 348 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp191_);
#line 2027 "PlaybackManager.c"
	}
#line 351 "../src/PlaybackManager.vala"
	result = rv;
#line 351 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 351 "../src/PlaybackManager.vala"
	return result;
#line 2035 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                     gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
#line 355 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 356 "../src/PlaybackManager.vala"
	rv = NULL;
#line 358 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 358 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 359 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 359 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 359 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 359 "../src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 2066 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		NoiseMedia* _tmp17_;
#line 360 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 360 "../src/PlaybackManager.vala"
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
#line 360 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 360 "../src/PlaybackManager.vala"
		if (_tmp6_) {
#line 2079 "PlaybackManager.c"
			{
				GeeIterator* _s_it = NULL;
				NoiseLibrary* _tmp7_;
				NoiseLibrary* _tmp8_;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _tmp12_;
#line 361 "../src/PlaybackManager.vala"
				_tmp7_ = noise_playback_manager_get_library (self);
#line 361 "../src/PlaybackManager.vala"
				_tmp8_ = _tmp7_;
#line 361 "../src/PlaybackManager.vala"
				_tmp9_ = noise_library_get_medias (_tmp8_);
#line 361 "../src/PlaybackManager.vala"
				_tmp10_ = _tmp9_;
#line 361 "../src/PlaybackManager.vala"
				_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 361 "../src/PlaybackManager.vala"
				_tmp12_ = _tmp11_;
#line 361 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp10_);
#line 361 "../src/PlaybackManager.vala"
				_s_it = _tmp12_;
#line 361 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 2106 "PlaybackManager.c"
					GeeIterator* _tmp13_;
					NoiseMedia* s = NULL;
					GeeIterator* _tmp14_;
					gpointer _tmp15_;
					NoiseMedia* _tmp16_;
#line 361 "../src/PlaybackManager.vala"
					_tmp13_ = _s_it;
#line 361 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp13_)) {
#line 361 "../src/PlaybackManager.vala"
						break;
#line 2118 "PlaybackManager.c"
					}
#line 361 "../src/PlaybackManager.vala"
					_tmp14_ = _s_it;
#line 361 "../src/PlaybackManager.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 361 "../src/PlaybackManager.vala"
					s = (NoiseMedia*) _tmp15_;
#line 362 "../src/PlaybackManager.vala"
					_tmp16_ = s;
#line 362 "../src/PlaybackManager.vala"
					noise_playback_manager_add_to_current (self, _tmp16_);
#line 361 "../src/PlaybackManager.vala"
					_g_object_unref0 (s);
#line 2132 "PlaybackManager.c"
				}
#line 361 "../src/PlaybackManager.vala"
				_g_object_unref0 (_s_it);
#line 2136 "PlaybackManager.c"
			}
#line 363 "../src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 2140 "PlaybackManager.c"
		}
#line 366 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 368 "../src/PlaybackManager.vala"
		_tmp17_ = self->priv->_current_media;
#line 368 "../src/PlaybackManager.vala"
		if (_tmp17_ == NULL) {
#line 2148 "PlaybackManager.c"
			GeeHashMap* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			GeeHashMap* _tmp21_;
			gint _tmp22_;
			gpointer _tmp23_;
#line 369 "../src/PlaybackManager.vala"
			_tmp18_ = self->priv->_current_shuffled;
#line 369 "../src/PlaybackManager.vala"
			_tmp19_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp18_);
#line 369 "../src/PlaybackManager.vala"
			_tmp20_ = _tmp19_;
#line 369 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = _tmp20_ - 1;
#line 370 "../src/PlaybackManager.vala"
			_tmp21_ = self->priv->_current_shuffled;
#line 370 "../src/PlaybackManager.vala"
			_tmp22_ = self->priv->_current_shuffled_index;
#line 370 "../src/PlaybackManager.vala"
			_tmp23_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, (gpointer) ((gintptr) _tmp22_));
#line 370 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 370 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp23_;
#line 2173 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp24_;
			NoiseSettingsRepeat _tmp25_;
			NoiseSettingsRepeat _tmp26_;
#line 371 "../src/PlaybackManager.vala"
			_tmp24_ = main_settings;
#line 371 "../src/PlaybackManager.vala"
			_tmp25_ = noise_settings_main_get_repeat_mode (_tmp24_);
#line 371 "../src/PlaybackManager.vala"
			_tmp26_ = _tmp25_;
#line 371 "../src/PlaybackManager.vala"
			if (_tmp26_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2186 "PlaybackManager.c"
				GeeHashMap* _tmp27_;
				gint _tmp28_;
				gpointer _tmp29_;
#line 372 "../src/PlaybackManager.vala"
				_tmp27_ = self->priv->_current_shuffled;
#line 372 "../src/PlaybackManager.vala"
				_tmp28_ = self->priv->_current_shuffled_index;
#line 372 "../src/PlaybackManager.vala"
				_tmp29_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) _tmp28_));
#line 372 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 372 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp29_;
#line 2200 "PlaybackManager.c"
			} else {
				gint _tmp30_;
#line 373 "../src/PlaybackManager.vala"
				_tmp30_ = self->priv->_current_shuffled_index;
#line 373 "../src/PlaybackManager.vala"
				if (_tmp30_ == 0) {
#line 2207 "PlaybackManager.c"
					NoiseSettingsMain* _tmp31_;
					NoiseSettingsRepeat _tmp32_;
					NoiseSettingsRepeat _tmp33_;
					GeeHashMap* _tmp37_;
					gint _tmp38_;
					gpointer _tmp39_;
#line 374 "../src/PlaybackManager.vala"
					_tmp31_ = main_settings;
#line 374 "../src/PlaybackManager.vala"
					_tmp32_ = noise_settings_main_get_repeat_mode (_tmp31_);
#line 374 "../src/PlaybackManager.vala"
					_tmp33_ = _tmp32_;
#line 374 "../src/PlaybackManager.vala"
					if (_tmp33_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2222 "PlaybackManager.c"
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
#line 375 "../src/PlaybackManager.vala"
						_tmp34_ = self->priv->_current_shuffled;
#line 375 "../src/PlaybackManager.vala"
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
#line 375 "../src/PlaybackManager.vala"
						_tmp36_ = _tmp35_;
#line 375 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp36_ - 1;
#line 2234 "PlaybackManager.c"
					} else {
#line 377 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 378 "../src/PlaybackManager.vala"
						result = NULL;
#line 378 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 378 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 378 "../src/PlaybackManager.vala"
						return result;
#line 2246 "PlaybackManager.c"
					}
#line 381 "../src/PlaybackManager.vala"
					_tmp37_ = self->priv->_current_shuffled;
#line 381 "../src/PlaybackManager.vala"
					_tmp38_ = self->priv->_current_shuffled_index;
#line 381 "../src/PlaybackManager.vala"
					_tmp39_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) _tmp38_));
#line 381 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 381 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp39_;
#line 2258 "PlaybackManager.c"
				} else {
					gboolean _tmp40_ = FALSE;
					gint _tmp41_;
#line 382 "../src/PlaybackManager.vala"
					_tmp41_ = self->priv->_current_shuffled_index;
#line 382 "../src/PlaybackManager.vala"
					if (_tmp41_ > 0) {
#line 2266 "PlaybackManager.c"
						gint _tmp42_;
						GeeHashMap* _tmp43_;
						gint _tmp44_;
						gint _tmp45_;
#line 382 "../src/PlaybackManager.vala"
						_tmp42_ = self->priv->_current_shuffled_index;
#line 382 "../src/PlaybackManager.vala"
						_tmp43_ = self->priv->_current_shuffled;
#line 382 "../src/PlaybackManager.vala"
						_tmp44_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp43_);
#line 382 "../src/PlaybackManager.vala"
						_tmp45_ = _tmp44_;
#line 382 "../src/PlaybackManager.vala"
						_tmp40_ = _tmp42_ < _tmp45_;
#line 2281 "PlaybackManager.c"
					} else {
#line 382 "../src/PlaybackManager.vala"
						_tmp40_ = FALSE;
#line 2285 "PlaybackManager.c"
					}
#line 382 "../src/PlaybackManager.vala"
					if (_tmp40_) {
#line 2289 "PlaybackManager.c"
						gboolean _tmp46_ = FALSE;
						NoiseSettingsMain* _tmp47_;
						NoiseSettingsRepeat _tmp48_;
						NoiseSettingsRepeat _tmp49_;
						GeeHashMap* _tmp101_;
						gint _tmp102_;
						gpointer _tmp103_;
#line 384 "../src/PlaybackManager.vala"
						_tmp47_ = main_settings;
#line 384 "../src/PlaybackManager.vala"
						_tmp48_ = noise_settings_main_get_repeat_mode (_tmp47_);
#line 384 "../src/PlaybackManager.vala"
						_tmp49_ = _tmp48_;
#line 384 "../src/PlaybackManager.vala"
						if (_tmp49_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2305 "PlaybackManager.c"
							GeeHashMap* _tmp50_;
							gint _tmp51_;
							gpointer _tmp52_;
							NoiseMedia* _tmp53_;
							const gchar* _tmp54_;
							const gchar* _tmp55_;
							GeeHashMap* _tmp56_;
							gint _tmp57_;
							gpointer _tmp58_;
							NoiseMedia* _tmp59_;
							const gchar* _tmp60_;
							const gchar* _tmp61_;
#line 384 "../src/PlaybackManager.vala"
							_tmp50_ = self->priv->_current_shuffled;
#line 384 "../src/PlaybackManager.vala"
							_tmp51_ = self->priv->_current_shuffled_index;
#line 384 "../src/PlaybackManager.vala"
							_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp50_, (gpointer) ((gintptr) (_tmp51_ - 1)));
#line 384 "../src/PlaybackManager.vala"
							_tmp53_ = (NoiseMedia*) _tmp52_;
#line 384 "../src/PlaybackManager.vala"
							_tmp54_ = noise_media_get_artist (_tmp53_);
#line 384 "../src/PlaybackManager.vala"
							_tmp55_ = _tmp54_;
#line 384 "../src/PlaybackManager.vala"
							_tmp56_ = self->priv->_current_shuffled;
#line 384 "../src/PlaybackManager.vala"
							_tmp57_ = self->priv->_current_shuffled_index;
#line 384 "../src/PlaybackManager.vala"
							_tmp58_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp56_, (gpointer) ((gintptr) _tmp57_));
#line 384 "../src/PlaybackManager.vala"
							_tmp59_ = (NoiseMedia*) _tmp58_;
#line 384 "../src/PlaybackManager.vala"
							_tmp60_ = noise_media_get_artist (_tmp59_);
#line 384 "../src/PlaybackManager.vala"
							_tmp61_ = _tmp60_;
#line 384 "../src/PlaybackManager.vala"
							_tmp46_ = g_strcmp0 (_tmp55_, _tmp61_) != 0;
#line 384 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp59_);
#line 384 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp53_);
#line 2348 "PlaybackManager.c"
						} else {
#line 384 "../src/PlaybackManager.vala"
							_tmp46_ = FALSE;
#line 2352 "PlaybackManager.c"
						}
#line 384 "../src/PlaybackManager.vala"
						if (_tmp46_) {
#line 385 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2358 "PlaybackManager.c"
								GeeHashMap* _tmp62_;
								gint _tmp63_;
								gpointer _tmp64_;
								NoiseMedia* _tmp65_;
								const gchar* _tmp66_;
								const gchar* _tmp67_;
								NoiseMedia* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								gboolean _tmp71_;
								gint _tmp72_;
#line 385 "../src/PlaybackManager.vala"
								_tmp62_ = self->priv->_current_shuffled;
#line 385 "../src/PlaybackManager.vala"
								_tmp63_ = self->priv->_current_shuffled_index;
#line 385 "../src/PlaybackManager.vala"
								_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp62_, (gpointer) ((gintptr) (_tmp63_ + 1)));
#line 385 "../src/PlaybackManager.vala"
								_tmp65_ = (NoiseMedia*) _tmp64_;
#line 385 "../src/PlaybackManager.vala"
								_tmp66_ = noise_media_get_artist (_tmp65_);
#line 385 "../src/PlaybackManager.vala"
								_tmp67_ = _tmp66_;
#line 385 "../src/PlaybackManager.vala"
								_tmp68_ = self->priv->_current_media;
#line 385 "../src/PlaybackManager.vala"
								_tmp69_ = noise_media_get_artist (_tmp68_);
#line 385 "../src/PlaybackManager.vala"
								_tmp70_ = _tmp69_;
#line 385 "../src/PlaybackManager.vala"
								_tmp71_ = !(g_strcmp0 (_tmp67_, _tmp70_) == 0);
#line 385 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp65_);
#line 385 "../src/PlaybackManager.vala"
								if (_tmp71_) {
#line 385 "../src/PlaybackManager.vala"
									break;
#line 2396 "PlaybackManager.c"
								}
#line 386 "../src/PlaybackManager.vala"
								_tmp72_ = self->priv->_current_shuffled_index;
#line 386 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp72_ + 1;
#line 2402 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp73_ = FALSE;
							NoiseSettingsMain* _tmp74_;
							NoiseSettingsRepeat _tmp75_;
							NoiseSettingsRepeat _tmp76_;
#line 387 "../src/PlaybackManager.vala"
							_tmp74_ = main_settings;
#line 387 "../src/PlaybackManager.vala"
							_tmp75_ = noise_settings_main_get_repeat_mode (_tmp74_);
#line 387 "../src/PlaybackManager.vala"
							_tmp76_ = _tmp75_;
#line 387 "../src/PlaybackManager.vala"
							if (_tmp76_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2417 "PlaybackManager.c"
								GeeHashMap* _tmp77_;
								gint _tmp78_;
								gpointer _tmp79_;
								NoiseMedia* _tmp80_;
								const gchar* _tmp81_;
								const gchar* _tmp82_;
								GeeHashMap* _tmp83_;
								gint _tmp84_;
								gpointer _tmp85_;
								NoiseMedia* _tmp86_;
								const gchar* _tmp87_;
								const gchar* _tmp88_;
#line 387 "../src/PlaybackManager.vala"
								_tmp77_ = self->priv->_current_shuffled;
#line 387 "../src/PlaybackManager.vala"
								_tmp78_ = self->priv->_current_shuffled_index;
#line 387 "../src/PlaybackManager.vala"
								_tmp79_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp77_, (gpointer) ((gintptr) (_tmp78_ - 1)));
#line 387 "../src/PlaybackManager.vala"
								_tmp80_ = (NoiseMedia*) _tmp79_;
#line 387 "../src/PlaybackManager.vala"
								_tmp81_ = noise_media_get_album (_tmp80_);
#line 387 "../src/PlaybackManager.vala"
								_tmp82_ = _tmp81_;
#line 387 "../src/PlaybackManager.vala"
								_tmp83_ = self->priv->_current_shuffled;
#line 387 "../src/PlaybackManager.vala"
								_tmp84_ = self->priv->_current_shuffled_index;
#line 387 "../src/PlaybackManager.vala"
								_tmp85_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp83_, (gpointer) ((gintptr) _tmp84_));
#line 387 "../src/PlaybackManager.vala"
								_tmp86_ = (NoiseMedia*) _tmp85_;
#line 387 "../src/PlaybackManager.vala"
								_tmp87_ = noise_media_get_album (_tmp86_);
#line 387 "../src/PlaybackManager.vala"
								_tmp88_ = _tmp87_;
#line 387 "../src/PlaybackManager.vala"
								_tmp73_ = g_strcmp0 (_tmp82_, _tmp88_) != 0;
#line 387 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp86_);
#line 387 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp80_);
#line 2460 "PlaybackManager.c"
							} else {
#line 387 "../src/PlaybackManager.vala"
								_tmp73_ = FALSE;
#line 2464 "PlaybackManager.c"
							}
#line 387 "../src/PlaybackManager.vala"
							if (_tmp73_) {
#line 388 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2470 "PlaybackManager.c"
									GeeHashMap* _tmp89_;
									gint _tmp90_;
									gpointer _tmp91_;
									NoiseMedia* _tmp92_;
									const gchar* _tmp93_;
									const gchar* _tmp94_;
									NoiseMedia* _tmp95_;
									const gchar* _tmp96_;
									const gchar* _tmp97_;
									gboolean _tmp98_;
									gint _tmp99_;
#line 388 "../src/PlaybackManager.vala"
									_tmp89_ = self->priv->_current_shuffled;
#line 388 "../src/PlaybackManager.vala"
									_tmp90_ = self->priv->_current_shuffled_index;
#line 388 "../src/PlaybackManager.vala"
									_tmp91_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp89_, (gpointer) ((gintptr) (_tmp90_ + 1)));
#line 388 "../src/PlaybackManager.vala"
									_tmp92_ = (NoiseMedia*) _tmp91_;
#line 388 "../src/PlaybackManager.vala"
									_tmp93_ = noise_media_get_album (_tmp92_);
#line 388 "../src/PlaybackManager.vala"
									_tmp94_ = _tmp93_;
#line 388 "../src/PlaybackManager.vala"
									_tmp95_ = self->priv->_current_media;
#line 388 "../src/PlaybackManager.vala"
									_tmp96_ = noise_media_get_album (_tmp95_);
#line 388 "../src/PlaybackManager.vala"
									_tmp97_ = _tmp96_;
#line 388 "../src/PlaybackManager.vala"
									_tmp98_ = !(g_strcmp0 (_tmp94_, _tmp97_) == 0);
#line 388 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp92_);
#line 388 "../src/PlaybackManager.vala"
									if (_tmp98_) {
#line 388 "../src/PlaybackManager.vala"
										break;
#line 2508 "PlaybackManager.c"
									}
#line 389 "../src/PlaybackManager.vala"
									_tmp99_ = self->priv->_current_shuffled_index;
#line 389 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp99_ + 1;
#line 2514 "PlaybackManager.c"
								}
							} else {
								gint _tmp100_;
#line 391 "../src/PlaybackManager.vala"
								_tmp100_ = self->priv->_current_shuffled_index;
#line 391 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp100_ - 1;
#line 2522 "PlaybackManager.c"
							}
						}
#line 393 "../src/PlaybackManager.vala"
						_tmp101_ = self->priv->_current_shuffled;
#line 393 "../src/PlaybackManager.vala"
						_tmp102_ = self->priv->_current_shuffled_index;
#line 393 "../src/PlaybackManager.vala"
						_tmp103_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp101_, (gpointer) ((gintptr) _tmp102_));
#line 393 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 393 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp103_;
#line 2535 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp104_;
						gint _tmp105_;
						gint _tmp106_;
						GeeHashMap* _tmp107_;
						gint _tmp108_;
						gpointer _tmp109_;
#line 395 "../src/PlaybackManager.vala"
						_tmp104_ = self->priv->_current_shuffled;
#line 395 "../src/PlaybackManager.vala"
						_tmp105_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp104_);
#line 395 "../src/PlaybackManager.vala"
						_tmp106_ = _tmp105_;
#line 395 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp106_ - 1;
#line 396 "../src/PlaybackManager.vala"
						_tmp107_ = self->priv->_current_shuffled;
#line 396 "../src/PlaybackManager.vala"
						_tmp108_ = self->priv->_current_shuffled_index;
#line 396 "../src/PlaybackManager.vala"
						_tmp109_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) _tmp108_));
#line 396 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 396 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp109_;
#line 2561 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp110_;
#line 399 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 401 "../src/PlaybackManager.vala"
		_tmp110_ = self->priv->_current_media;
#line 401 "../src/PlaybackManager.vala"
		if (_tmp110_ == NULL) {
#line 2574 "PlaybackManager.c"
			GeeHashMap* _tmp111_;
			gint _tmp112_;
			gint _tmp113_;
			GeeHashMap* _tmp114_;
			gint _tmp115_;
			gpointer _tmp116_;
#line 402 "../src/PlaybackManager.vala"
			_tmp111_ = self->priv->_current;
#line 402 "../src/PlaybackManager.vala"
			_tmp112_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp111_);
#line 402 "../src/PlaybackManager.vala"
			_tmp113_ = _tmp112_;
#line 402 "../src/PlaybackManager.vala"
			self->priv->_current_index = _tmp113_ - 1;
#line 403 "../src/PlaybackManager.vala"
			_tmp114_ = self->priv->_current;
#line 403 "../src/PlaybackManager.vala"
			_tmp115_ = self->priv->_current_index;
#line 403 "../src/PlaybackManager.vala"
			_tmp116_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp114_, (gpointer) ((gintptr) _tmp115_));
#line 403 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 403 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp116_;
#line 2599 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp117_;
			NoiseSettingsRepeat _tmp118_;
			NoiseSettingsRepeat _tmp119_;
#line 404 "../src/PlaybackManager.vala"
			_tmp117_ = main_settings;
#line 404 "../src/PlaybackManager.vala"
			_tmp118_ = noise_settings_main_get_repeat_mode (_tmp117_);
#line 404 "../src/PlaybackManager.vala"
			_tmp119_ = _tmp118_;
#line 404 "../src/PlaybackManager.vala"
			if (_tmp119_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2612 "PlaybackManager.c"
				GeeHashMap* _tmp120_;
				gint _tmp121_;
				gpointer _tmp122_;
#line 405 "../src/PlaybackManager.vala"
				_tmp120_ = self->priv->_current;
#line 405 "../src/PlaybackManager.vala"
				_tmp121_ = self->priv->_current_index;
#line 405 "../src/PlaybackManager.vala"
				_tmp122_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp120_, (gpointer) ((gintptr) _tmp121_));
#line 405 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 405 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp122_;
#line 2626 "PlaybackManager.c"
			} else {
				gint _tmp123_;
#line 406 "../src/PlaybackManager.vala"
				_tmp123_ = self->priv->_current_index;
#line 406 "../src/PlaybackManager.vala"
				if (_tmp123_ == 0) {
#line 2633 "PlaybackManager.c"
					NoiseSettingsMain* _tmp124_;
					NoiseSettingsRepeat _tmp125_;
					NoiseSettingsRepeat _tmp126_;
					GeeHashMap* _tmp130_;
					gint _tmp131_;
					gpointer _tmp132_;
#line 407 "../src/PlaybackManager.vala"
					_tmp124_ = main_settings;
#line 407 "../src/PlaybackManager.vala"
					_tmp125_ = noise_settings_main_get_repeat_mode (_tmp124_);
#line 407 "../src/PlaybackManager.vala"
					_tmp126_ = _tmp125_;
#line 407 "../src/PlaybackManager.vala"
					if (_tmp126_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2648 "PlaybackManager.c"
						GeeHashMap* _tmp127_;
						gint _tmp128_;
						gint _tmp129_;
#line 408 "../src/PlaybackManager.vala"
						_tmp127_ = self->priv->_current;
#line 408 "../src/PlaybackManager.vala"
						_tmp128_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp127_);
#line 408 "../src/PlaybackManager.vala"
						_tmp129_ = _tmp128_;
#line 408 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp129_ - 1;
#line 2660 "PlaybackManager.c"
					} else {
#line 410 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 411 "../src/PlaybackManager.vala"
						result = NULL;
#line 411 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 411 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 411 "../src/PlaybackManager.vala"
						return result;
#line 2672 "PlaybackManager.c"
					}
#line 414 "../src/PlaybackManager.vala"
					_tmp130_ = self->priv->_current;
#line 414 "../src/PlaybackManager.vala"
					_tmp131_ = self->priv->_current_index;
#line 414 "../src/PlaybackManager.vala"
					_tmp132_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp130_, (gpointer) ((gintptr) _tmp131_));
#line 414 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 414 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp132_;
#line 2684 "PlaybackManager.c"
				} else {
					gboolean _tmp133_ = FALSE;
					gint _tmp134_;
#line 415 "../src/PlaybackManager.vala"
					_tmp134_ = self->priv->_current_index;
#line 415 "../src/PlaybackManager.vala"
					if (_tmp134_ > 0) {
#line 2692 "PlaybackManager.c"
						gint _tmp135_;
						GeeHashMap* _tmp136_;
						gint _tmp137_;
						gint _tmp138_;
#line 415 "../src/PlaybackManager.vala"
						_tmp135_ = self->priv->_current_index;
#line 415 "../src/PlaybackManager.vala"
						_tmp136_ = self->priv->_current;
#line 415 "../src/PlaybackManager.vala"
						_tmp137_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp136_);
#line 415 "../src/PlaybackManager.vala"
						_tmp138_ = _tmp137_;
#line 415 "../src/PlaybackManager.vala"
						_tmp133_ = _tmp135_ < _tmp138_;
#line 2707 "PlaybackManager.c"
					} else {
#line 415 "../src/PlaybackManager.vala"
						_tmp133_ = FALSE;
#line 2711 "PlaybackManager.c"
					}
#line 415 "../src/PlaybackManager.vala"
					if (_tmp133_) {
#line 2715 "PlaybackManager.c"
						gboolean _tmp139_ = FALSE;
						NoiseSettingsMain* _tmp140_;
						NoiseSettingsRepeat _tmp141_;
						NoiseSettingsRepeat _tmp142_;
						GeeHashMap* _tmp194_;
						gint _tmp195_;
						gpointer _tmp196_;
#line 417 "../src/PlaybackManager.vala"
						_tmp140_ = main_settings;
#line 417 "../src/PlaybackManager.vala"
						_tmp141_ = noise_settings_main_get_repeat_mode (_tmp140_);
#line 417 "../src/PlaybackManager.vala"
						_tmp142_ = _tmp141_;
#line 417 "../src/PlaybackManager.vala"
						if (_tmp142_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2731 "PlaybackManager.c"
							GeeHashMap* _tmp143_;
							gint _tmp144_;
							gpointer _tmp145_;
							NoiseMedia* _tmp146_;
							const gchar* _tmp147_;
							const gchar* _tmp148_;
							GeeHashMap* _tmp149_;
							gint _tmp150_;
							gpointer _tmp151_;
							NoiseMedia* _tmp152_;
							const gchar* _tmp153_;
							const gchar* _tmp154_;
#line 417 "../src/PlaybackManager.vala"
							_tmp143_ = self->priv->_current;
#line 417 "../src/PlaybackManager.vala"
							_tmp144_ = self->priv->_current_index;
#line 417 "../src/PlaybackManager.vala"
							_tmp145_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp143_, (gpointer) ((gintptr) (_tmp144_ - 1)));
#line 417 "../src/PlaybackManager.vala"
							_tmp146_ = (NoiseMedia*) _tmp145_;
#line 417 "../src/PlaybackManager.vala"
							_tmp147_ = noise_media_get_artist (_tmp146_);
#line 417 "../src/PlaybackManager.vala"
							_tmp148_ = _tmp147_;
#line 417 "../src/PlaybackManager.vala"
							_tmp149_ = self->priv->_current;
#line 417 "../src/PlaybackManager.vala"
							_tmp150_ = self->priv->_current_index;
#line 417 "../src/PlaybackManager.vala"
							_tmp151_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp149_, (gpointer) ((gintptr) _tmp150_));
#line 417 "../src/PlaybackManager.vala"
							_tmp152_ = (NoiseMedia*) _tmp151_;
#line 417 "../src/PlaybackManager.vala"
							_tmp153_ = noise_media_get_artist (_tmp152_);
#line 417 "../src/PlaybackManager.vala"
							_tmp154_ = _tmp153_;
#line 417 "../src/PlaybackManager.vala"
							_tmp139_ = g_strcmp0 (_tmp148_, _tmp154_) != 0;
#line 417 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp152_);
#line 417 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp146_);
#line 2774 "PlaybackManager.c"
						} else {
#line 417 "../src/PlaybackManager.vala"
							_tmp139_ = FALSE;
#line 2778 "PlaybackManager.c"
						}
#line 417 "../src/PlaybackManager.vala"
						if (_tmp139_) {
#line 418 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2784 "PlaybackManager.c"
								GeeHashMap* _tmp155_;
								gint _tmp156_;
								gpointer _tmp157_;
								NoiseMedia* _tmp158_;
								const gchar* _tmp159_;
								const gchar* _tmp160_;
								NoiseMedia* _tmp161_;
								const gchar* _tmp162_;
								const gchar* _tmp163_;
								gboolean _tmp164_;
								gint _tmp165_;
#line 418 "../src/PlaybackManager.vala"
								_tmp155_ = self->priv->_current;
#line 418 "../src/PlaybackManager.vala"
								_tmp156_ = self->priv->_current_index;
#line 418 "../src/PlaybackManager.vala"
								_tmp157_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp155_, (gpointer) ((gintptr) (_tmp156_ + 1)));
#line 418 "../src/PlaybackManager.vala"
								_tmp158_ = (NoiseMedia*) _tmp157_;
#line 418 "../src/PlaybackManager.vala"
								_tmp159_ = noise_media_get_artist (_tmp158_);
#line 418 "../src/PlaybackManager.vala"
								_tmp160_ = _tmp159_;
#line 418 "../src/PlaybackManager.vala"
								_tmp161_ = self->priv->_current_media;
#line 418 "../src/PlaybackManager.vala"
								_tmp162_ = noise_media_get_artist (_tmp161_);
#line 418 "../src/PlaybackManager.vala"
								_tmp163_ = _tmp162_;
#line 418 "../src/PlaybackManager.vala"
								_tmp164_ = !(g_strcmp0 (_tmp160_, _tmp163_) == 0);
#line 418 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp158_);
#line 418 "../src/PlaybackManager.vala"
								if (_tmp164_) {
#line 418 "../src/PlaybackManager.vala"
									break;
#line 2822 "PlaybackManager.c"
								}
#line 419 "../src/PlaybackManager.vala"
								_tmp165_ = self->priv->_current_index;
#line 419 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp165_ + 1;
#line 2828 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp166_ = FALSE;
							NoiseSettingsMain* _tmp167_;
							NoiseSettingsRepeat _tmp168_;
							NoiseSettingsRepeat _tmp169_;
#line 420 "../src/PlaybackManager.vala"
							_tmp167_ = main_settings;
#line 420 "../src/PlaybackManager.vala"
							_tmp168_ = noise_settings_main_get_repeat_mode (_tmp167_);
#line 420 "../src/PlaybackManager.vala"
							_tmp169_ = _tmp168_;
#line 420 "../src/PlaybackManager.vala"
							if (_tmp169_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2843 "PlaybackManager.c"
								GeeHashMap* _tmp170_;
								gint _tmp171_;
								gpointer _tmp172_;
								NoiseMedia* _tmp173_;
								const gchar* _tmp174_;
								const gchar* _tmp175_;
								GeeHashMap* _tmp176_;
								gint _tmp177_;
								gpointer _tmp178_;
								NoiseMedia* _tmp179_;
								const gchar* _tmp180_;
								const gchar* _tmp181_;
#line 420 "../src/PlaybackManager.vala"
								_tmp170_ = self->priv->_current;
#line 420 "../src/PlaybackManager.vala"
								_tmp171_ = self->priv->_current_index;
#line 420 "../src/PlaybackManager.vala"
								_tmp172_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp170_, (gpointer) ((gintptr) (_tmp171_ - 1)));
#line 420 "../src/PlaybackManager.vala"
								_tmp173_ = (NoiseMedia*) _tmp172_;
#line 420 "../src/PlaybackManager.vala"
								_tmp174_ = noise_media_get_album (_tmp173_);
#line 420 "../src/PlaybackManager.vala"
								_tmp175_ = _tmp174_;
#line 420 "../src/PlaybackManager.vala"
								_tmp176_ = self->priv->_current;
#line 420 "../src/PlaybackManager.vala"
								_tmp177_ = self->priv->_current_index;
#line 420 "../src/PlaybackManager.vala"
								_tmp178_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp176_, (gpointer) ((gintptr) _tmp177_));
#line 420 "../src/PlaybackManager.vala"
								_tmp179_ = (NoiseMedia*) _tmp178_;
#line 420 "../src/PlaybackManager.vala"
								_tmp180_ = noise_media_get_album (_tmp179_);
#line 420 "../src/PlaybackManager.vala"
								_tmp181_ = _tmp180_;
#line 420 "../src/PlaybackManager.vala"
								_tmp166_ = g_strcmp0 (_tmp175_, _tmp181_) != 0;
#line 420 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp179_);
#line 420 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp173_);
#line 2886 "PlaybackManager.c"
							} else {
#line 420 "../src/PlaybackManager.vala"
								_tmp166_ = FALSE;
#line 2890 "PlaybackManager.c"
							}
#line 420 "../src/PlaybackManager.vala"
							if (_tmp166_) {
#line 421 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2896 "PlaybackManager.c"
									GeeHashMap* _tmp182_;
									gint _tmp183_;
									gpointer _tmp184_;
									NoiseMedia* _tmp185_;
									const gchar* _tmp186_;
									const gchar* _tmp187_;
									NoiseMedia* _tmp188_;
									const gchar* _tmp189_;
									const gchar* _tmp190_;
									gboolean _tmp191_;
									gint _tmp192_;
#line 421 "../src/PlaybackManager.vala"
									_tmp182_ = self->priv->_current;
#line 421 "../src/PlaybackManager.vala"
									_tmp183_ = self->priv->_current_index;
#line 421 "../src/PlaybackManager.vala"
									_tmp184_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp182_, (gpointer) ((gintptr) (_tmp183_ + 1)));
#line 421 "../src/PlaybackManager.vala"
									_tmp185_ = (NoiseMedia*) _tmp184_;
#line 421 "../src/PlaybackManager.vala"
									_tmp186_ = noise_media_get_album (_tmp185_);
#line 421 "../src/PlaybackManager.vala"
									_tmp187_ = _tmp186_;
#line 421 "../src/PlaybackManager.vala"
									_tmp188_ = self->priv->_current_media;
#line 421 "../src/PlaybackManager.vala"
									_tmp189_ = noise_media_get_album (_tmp188_);
#line 421 "../src/PlaybackManager.vala"
									_tmp190_ = _tmp189_;
#line 421 "../src/PlaybackManager.vala"
									_tmp191_ = !(g_strcmp0 (_tmp187_, _tmp190_) == 0);
#line 421 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp185_);
#line 421 "../src/PlaybackManager.vala"
									if (_tmp191_) {
#line 421 "../src/PlaybackManager.vala"
										break;
#line 2934 "PlaybackManager.c"
									}
#line 422 "../src/PlaybackManager.vala"
									_tmp192_ = self->priv->_current_index;
#line 422 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp192_ + 1;
#line 2940 "PlaybackManager.c"
								}
							} else {
								gint _tmp193_;
#line 424 "../src/PlaybackManager.vala"
								_tmp193_ = self->priv->_current_index;
#line 424 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp193_ - 1;
#line 2948 "PlaybackManager.c"
							}
						}
#line 427 "../src/PlaybackManager.vala"
						_tmp194_ = self->priv->_current;
#line 427 "../src/PlaybackManager.vala"
						_tmp195_ = self->priv->_current_index;
#line 427 "../src/PlaybackManager.vala"
						_tmp196_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp194_, (gpointer) ((gintptr) _tmp195_));
#line 427 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 427 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp196_;
#line 2961 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp207_;
						gint _tmp208_;
						gint _tmp209_;
						GeeHashMap* _tmp210_;
						gint _tmp211_;
						gpointer _tmp212_;
						{
							GeeIterator* _s_it = NULL;
							NoiseLibrary* _tmp197_;
							NoiseLibrary* _tmp198_;
							GeeCollection* _tmp199_;
							GeeCollection* _tmp200_;
							GeeIterator* _tmp201_;
							GeeIterator* _tmp202_;
#line 429 "../src/PlaybackManager.vala"
							_tmp197_ = noise_playback_manager_get_library (self);
#line 429 "../src/PlaybackManager.vala"
							_tmp198_ = _tmp197_;
#line 429 "../src/PlaybackManager.vala"
							_tmp199_ = noise_library_get_medias (_tmp198_);
#line 429 "../src/PlaybackManager.vala"
							_tmp200_ = _tmp199_;
#line 429 "../src/PlaybackManager.vala"
							_tmp201_ = gee_iterable_iterator ((GeeIterable*) _tmp200_);
#line 429 "../src/PlaybackManager.vala"
							_tmp202_ = _tmp201_;
#line 429 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp200_);
#line 429 "../src/PlaybackManager.vala"
							_s_it = _tmp202_;
#line 429 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2995 "PlaybackManager.c"
								GeeIterator* _tmp203_;
								NoiseMedia* s = NULL;
								GeeIterator* _tmp204_;
								gpointer _tmp205_;
								NoiseMedia* _tmp206_;
#line 429 "../src/PlaybackManager.vala"
								_tmp203_ = _s_it;
#line 429 "../src/PlaybackManager.vala"
								if (!gee_iterator_next (_tmp203_)) {
#line 429 "../src/PlaybackManager.vala"
									break;
#line 3007 "PlaybackManager.c"
								}
#line 429 "../src/PlaybackManager.vala"
								_tmp204_ = _s_it;
#line 429 "../src/PlaybackManager.vala"
								_tmp205_ = gee_iterator_get (_tmp204_);
#line 429 "../src/PlaybackManager.vala"
								s = (NoiseMedia*) _tmp205_;
#line 430 "../src/PlaybackManager.vala"
								_tmp206_ = s;
#line 430 "../src/PlaybackManager.vala"
								noise_playback_manager_add_to_current (self, _tmp206_);
#line 429 "../src/PlaybackManager.vala"
								_g_object_unref0 (s);
#line 3021 "PlaybackManager.c"
							}
#line 429 "../src/PlaybackManager.vala"
							_g_object_unref0 (_s_it);
#line 3025 "PlaybackManager.c"
						}
#line 432 "../src/PlaybackManager.vala"
						_tmp207_ = self->priv->_current;
#line 432 "../src/PlaybackManager.vala"
						_tmp208_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp207_);
#line 432 "../src/PlaybackManager.vala"
						_tmp209_ = _tmp208_;
#line 432 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp209_ - 1;
#line 433 "../src/PlaybackManager.vala"
						_tmp210_ = self->priv->_current;
#line 433 "../src/PlaybackManager.vala"
						_tmp211_ = self->priv->_current_index;
#line 433 "../src/PlaybackManager.vala"
						_tmp212_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp210_, (gpointer) ((gintptr) _tmp211_));
#line 433 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 433 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp212_;
#line 3045 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 437 "../src/PlaybackManager.vala"
	if (play) {
#line 3053 "PlaybackManager.c"
		NoiseMedia* _tmp213_;
#line 438 "../src/PlaybackManager.vala"
		_tmp213_ = rv;
#line 438 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp213_);
#line 3059 "PlaybackManager.c"
	}
#line 441 "../src/PlaybackManager.vala"
	result = rv;
#line 441 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 441 "../src/PlaybackManager.vala"
	return result;
#line 3067 "PlaybackManager.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 444 "../src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 3076 "PlaybackManager.c"
}


static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 444 "../src/PlaybackManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 444 "../src/PlaybackManager.vala"
	return _data10_;
#line 3087 "PlaybackManager.c"
}


static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 444 "../src/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3098 "PlaybackManager.c"
		NoisePlaybackManager* self;
#line 444 "../src/PlaybackManager.vala"
		self = _data10_->self;
#line 444 "../src/PlaybackManager.vala"
		_g_object_unref0 (_data10_->m);
#line 444 "../src/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 444 "../src/PlaybackManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 3108 "PlaybackManager.c"
	}
}


static gboolean
__lambda33_ (Block10Data* _data10_)
{
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 525 "../src/PlaybackManager.vala"
	self = _data10_->self;
#line 526 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 3123 "PlaybackManager.c"
		NoiseMedia* _tmp1_;
#line 526 "../src/PlaybackManager.vala"
		_tmp1_ = self->priv->_current_media;
#line 526 "../src/PlaybackManager.vala"
		_tmp0_ = _tmp1_ == _data10_->m;
#line 3129 "PlaybackManager.c"
	} else {
#line 526 "../src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 3133 "PlaybackManager.c"
	}
#line 526 "../src/PlaybackManager.vala"
	if (_tmp0_) {
#line 3137 "PlaybackManager.c"
		NoiseHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp3_;
		guint _tmp4_;
#line 527 "../src/PlaybackManager.vala"
		_tmp2_ = self->history_playlist;
#line 527 "../src/PlaybackManager.vala"
		noise_playlist_add_media ((NoisePlaylist*) _tmp2_, _data10_->m);
#line 529 "../src/PlaybackManager.vala"
		_tmp3_ = self->player;
#line 529 "../src/PlaybackManager.vala"
		player_duration_s = (guint) (noise_playback_get_duration (_tmp3_) / NOISE_TIME_UTILS_NANO_INV);
#line 530 "../src/PlaybackManager.vala"
		_tmp4_ = player_duration_s;
#line 530 "../src/PlaybackManager.vala"
		if (_tmp4_ > ((guint) 1)) {
#line 3154 "PlaybackManager.c"
			gint delta_s = 0;
			guint _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_;
#line 531 "../src/PlaybackManager.vala"
			_tmp5_ = player_duration_s;
#line 531 "../src/PlaybackManager.vala"
			_tmp6_ = noise_media_get_length (_data10_->m);
#line 531 "../src/PlaybackManager.vala"
			_tmp7_ = _tmp6_;
#line 531 "../src/PlaybackManager.vala"
			delta_s = ((gint) _tmp5_) - ((gint) (_tmp7_ / NOISE_TIME_UTILS_MILI_INV));
#line 532 "../src/PlaybackManager.vala"
			_tmp8_ = delta_s;
#line 532 "../src/PlaybackManager.vala"
			if (fabs ((gdouble) _tmp8_) > ((gdouble) 3)) {
#line 3172 "PlaybackManager.c"
				guint _tmp9_;
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
#line 533 "../src/PlaybackManager.vala"
				_tmp9_ = player_duration_s;
#line 533 "../src/PlaybackManager.vala"
				noise_media_set_length (_data10_->m, (guint) (_tmp9_ * NOISE_TIME_UTILS_MILI_INV));
#line 534 "../src/PlaybackManager.vala"
				_tmp10_ = noise_playback_manager_get_library (self);
#line 534 "../src/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 534 "../src/PlaybackManager.vala"
				noise_library_update_media (_tmp11_, _data10_->m, FALSE, FALSE);
#line 3186 "PlaybackManager.c"
			}
		}
	}
#line 539 "../src/PlaybackManager.vala"
	result = FALSE;
#line 539 "../src/PlaybackManager.vala"
	return result;
#line 3194 "PlaybackManager.c"
}


static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
#line 525 "../src/PlaybackManager.vala"
	return result;
#line 3205 "PlaybackManager.c"
}


void
noise_playback_manager_play_media (NoisePlaybackManager* self,
                                   NoiseMedia* m)
{
	Block10Data* _data10_;
	NoiseMedia* _tmp0_;
	gint64 old_id = 0LL;
	NoiseMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	gboolean _tmp39_;
	GFile* _tmp44_;
	GFile* _tmp45_;
	NoisePlayback* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp58_ = FALSE;
	gint64 _tmp59_;
	gint64 _tmp60_;
	GError * _inner_error_ = NULL;
#line 444 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 444 "../src/PlaybackManager.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 444 "../src/PlaybackManager.vala"
	_data10_->_ref_count_ = 1;
#line 444 "../src/PlaybackManager.vala"
	_data10_->self = g_object_ref (self);
#line 444 "../src/PlaybackManager.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 444 "../src/PlaybackManager.vala"
	_g_object_unref0 (_data10_->m);
#line 444 "../src/PlaybackManager.vala"
	_data10_->m = _tmp0_;
#line 445 "../src/PlaybackManager.vala"
	old_id = (gint64) -1;
#line 448 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 448 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 3251 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 449 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 449 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 449 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 449 "../src/PlaybackManager.vala"
		old_id = _tmp4_;
#line 3263 "PlaybackManager.c"
	}
#line 451 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, _data10_->m);
#line 455 "../src/PlaybackManager.vala"
	_tmp5_ = noise_media_get_location_unknown (_data10_->m);
#line 455 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 455 "../src/PlaybackManager.vala"
	if (_tmp6_) {
#line 3273 "PlaybackManager.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
#line 456 "../src/PlaybackManager.vala"
		_tmp7_ = noise_media_get_uri (_data10_->m);
#line 456 "../src/PlaybackManager.vala"
		_tmp8_ = _tmp7_;
#line 456 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 456 "../src/PlaybackManager.vala"
		_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 456 "../src/PlaybackManager.vala"
		_tmp11_ = _tmp10_;
#line 456 "../src/PlaybackManager.vala"
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 456 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp11_);
#line 456 "../src/PlaybackManager.vala"
		_g_free0 (_tmp9_);
#line 456 "../src/PlaybackManager.vala"
		if (_tmp12_) {
#line 457 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 458 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 3302 "PlaybackManager.c"
		} else {
#line 461 "../src/PlaybackManager.vala"
			noise_playback_manager_stop_playback (self);
#line 462 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 462 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 462 "../src/PlaybackManager.vala"
			return;
#line 3312 "PlaybackManager.c"
		}
	}
#line 466 "../src/PlaybackManager.vala"
	found = FALSE;
#line 3317 "PlaybackManager.c"
	{
		GeeTreeSet* _tmp13_;
#line 467 "../src/PlaybackManager.vala"
		_tmp13_ = self->priv->playbacks;
#line 467 "../src/PlaybackManager.vala"
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
#line 3324 "PlaybackManager.c"
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
#line 468 "../src/PlaybackManager.vala"
				_tmp14_ = self->priv->playbacks;
#line 468 "../src/PlaybackManager.vala"
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 468 "../src/PlaybackManager.vala"
				_playback_it = _tmp15_;
#line 468 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 3338 "PlaybackManager.c"
					GeeIterator* _tmp16_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					gboolean _tmp37_;
#line 468 "../src/PlaybackManager.vala"
					_tmp16_ = _playback_it;
#line 468 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 468 "../src/PlaybackManager.vala"
						break;
#line 3350 "PlaybackManager.c"
					}
#line 468 "../src/PlaybackManager.vala"
					_tmp17_ = _playback_it;
#line 468 "../src/PlaybackManager.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 468 "../src/PlaybackManager.vala"
					playback = (NoisePlayback*) _tmp18_;
#line 3358 "PlaybackManager.c"
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
#line 469 "../src/PlaybackManager.vala"
						_tmp19_ = playback;
#line 469 "../src/PlaybackManager.vala"
						_tmp20_ = noise_playback_get_supported_uri (_tmp19_);
#line 469 "../src/PlaybackManager.vala"
						_tmp21_ = _tmp20_;
#line 469 "../src/PlaybackManager.vala"
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 469 "../src/PlaybackManager.vala"
						_tmp23_ = _tmp22_;
#line 469 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp21_);
#line 469 "../src/PlaybackManager.vala"
						_supported_uri_it = _tmp23_;
#line 469 "../src/PlaybackManager.vala"
						while (TRUE) {
#line 3382 "PlaybackManager.c"
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
#line 469 "../src/PlaybackManager.vala"
							_tmp24_ = _supported_uri_it;
#line 469 "../src/PlaybackManager.vala"
							if (!gee_iterator_next (_tmp24_)) {
#line 469 "../src/PlaybackManager.vala"
								break;
#line 3398 "PlaybackManager.c"
							}
#line 469 "../src/PlaybackManager.vala"
							_tmp25_ = _supported_uri_it;
#line 469 "../src/PlaybackManager.vala"
							_tmp26_ = gee_iterator_get (_tmp25_);
#line 469 "../src/PlaybackManager.vala"
							supported_uri = (gchar*) _tmp26_;
#line 470 "../src/PlaybackManager.vala"
							_tmp27_ = noise_media_get_uri (_data10_->m);
#line 470 "../src/PlaybackManager.vala"
							_tmp28_ = _tmp27_;
#line 470 "../src/PlaybackManager.vala"
							_tmp29_ = _tmp28_;
#line 470 "../src/PlaybackManager.vala"
							_tmp30_ = supported_uri;
#line 470 "../src/PlaybackManager.vala"
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
#line 470 "../src/PlaybackManager.vala"
							_g_free0 (_tmp29_);
#line 470 "../src/PlaybackManager.vala"
							if (_tmp31_) {
#line 3420 "PlaybackManager.c"
								NoisePlayback* _tmp32_;
								NoisePlayback* _tmp33_;
								NoisePlayback* _tmp34_;
								NoisePlayback* _tmp35_;
								gdouble _tmp36_;
#line 471 "../src/PlaybackManager.vala"
								_tmp32_ = self->player;
#line 471 "../src/PlaybackManager.vala"
								self->priv->saved_volume = noise_playback_get_volume (_tmp32_);
#line 472 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
#line 473 "../src/PlaybackManager.vala"
								_tmp33_ = self->player;
#line 473 "../src/PlaybackManager.vala"
								noise_playback_set_state (_tmp33_, GST_STATE_NULL);
#line 474 "../src/PlaybackManager.vala"
								found = TRUE;
#line 475 "../src/PlaybackManager.vala"
								_tmp34_ = playback;
#line 475 "../src/PlaybackManager.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 475 "../src/PlaybackManager.vala"
								_g_object_unref0 (self->player);
#line 475 "../src/PlaybackManager.vala"
								self->player = _tmp35_;
#line 476 "../src/PlaybackManager.vala"
								_tmp36_ = self->priv->saved_volume;
#line 476 "../src/PlaybackManager.vala"
								noise_playback_manager_set_volume (self, _tmp36_);
#line 477 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
#line 478 "../src/PlaybackManager.vala"
								_g_free0 (supported_uri);
#line 478 "../src/PlaybackManager.vala"
								break;
#line 3456 "PlaybackManager.c"
							}
#line 469 "../src/PlaybackManager.vala"
							_g_free0 (supported_uri);
#line 3460 "PlaybackManager.c"
						}
#line 469 "../src/PlaybackManager.vala"
						_g_object_unref0 (_supported_uri_it);
#line 3464 "PlaybackManager.c"
					}
#line 481 "../src/PlaybackManager.vala"
					_tmp37_ = found;
#line 481 "../src/PlaybackManager.vala"
					if (_tmp37_ == TRUE) {
#line 482 "../src/PlaybackManager.vala"
						break;
#line 3472 "PlaybackManager.c"
					}
				}
#line 468 "../src/PlaybackManager.vala"
				_g_object_unref0 (_playback_it);
#line 3477 "PlaybackManager.c"
			}
		}
		__finally19:
		{
			GeeTreeSet* _tmp38_;
#line 467 "../src/PlaybackManager.vala"
			_tmp38_ = self->priv->playbacks;
#line 467 "../src/PlaybackManager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
#line 3487 "PlaybackManager.c"
		}
#line 467 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 467 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 467 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 467 "../src/PlaybackManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 467 "../src/PlaybackManager.vala"
			g_clear_error (&_inner_error_);
#line 467 "../src/PlaybackManager.vala"
			return;
#line 3501 "PlaybackManager.c"
		}
	}
#line 486 "../src/PlaybackManager.vala"
	_tmp39_ = found;
#line 486 "../src/PlaybackManager.vala"
	if (!_tmp39_) {
#line 3508 "PlaybackManager.c"
		GThemedIcon* _tmp40_;
		GThemedIcon* _tmp41_;
		NoiseMedia* _tmp42_;
		NoiseMedia* _tmp43_;
#line 487 "../src/PlaybackManager.vala"
		_tmp40_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 487 "../src/PlaybackManager.vala"
		_tmp41_ = _tmp40_;
#line 487 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp41_);
#line 487 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp41_);
#line 488 "../src/PlaybackManager.vala"
		_tmp42_ = noise_playback_manager_get_next (self, TRUE);
#line 488 "../src/PlaybackManager.vala"
		_tmp43_ = _tmp42_;
#line 488 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp43_);
#line 489 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 489 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 489 "../src/PlaybackManager.vala"
		return;
#line 3533 "PlaybackManager.c"
	}
#line 493 "../src/PlaybackManager.vala"
	_tmp44_ = noise_media_get_file (_data10_->m);
#line 493 "../src/PlaybackManager.vala"
	_tmp45_ = _tmp44_;
#line 493 "../src/PlaybackManager.vala"
	if (!g_file_query_exists (_tmp45_, NULL)) {
#line 3541 "PlaybackManager.c"
		GThemedIcon* _tmp46_;
		GThemedIcon* _tmp47_;
		NoiseMedia* _tmp48_;
		NoiseMedia* _tmp49_;
#line 494 "../src/PlaybackManager.vala"
		_tmp46_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 494 "../src/PlaybackManager.vala"
		_tmp47_ = _tmp46_;
#line 494 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp47_);
#line 494 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp47_);
#line 495 "../src/PlaybackManager.vala"
		noise_media_set_location_unknown (_data10_->m, TRUE);
#line 497 "../src/PlaybackManager.vala"
		_tmp48_ = noise_playback_manager_get_next (self, TRUE);
#line 497 "../src/PlaybackManager.vala"
		_tmp49_ = _tmp48_;
#line 497 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp49_);
#line 498 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 498 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 498 "../src/PlaybackManager.vala"
		return;
#line 3568 "PlaybackManager.c"
	} else {
		gboolean _tmp50_ = FALSE;
		gboolean _tmp51_;
		gboolean _tmp52_;
#line 500 "../src/PlaybackManager.vala"
		_tmp51_ = noise_media_get_location_unknown (_data10_->m);
#line 500 "../src/PlaybackManager.vala"
		_tmp52_ = _tmp51_;
#line 500 "../src/PlaybackManager.vala"
		if (_tmp52_) {
#line 3579 "PlaybackManager.c"
			GIcon* _tmp53_;
			GIcon* _tmp54_;
#line 500 "../src/PlaybackManager.vala"
			_tmp53_ = noise_media_get_unique_status_image (_data10_->m);
#line 500 "../src/PlaybackManager.vala"
			_tmp54_ = _tmp53_;
#line 500 "../src/PlaybackManager.vala"
			_tmp50_ = _tmp54_ != NULL;
#line 3588 "PlaybackManager.c"
		} else {
#line 500 "../src/PlaybackManager.vala"
			_tmp50_ = FALSE;
#line 3592 "PlaybackManager.c"
		}
#line 500 "../src/PlaybackManager.vala"
		if (_tmp50_) {
#line 501 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 502 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 3600 "PlaybackManager.c"
		}
	}
#line 506 "../src/PlaybackManager.vala"
	noise_playback_manager_change_gains_thread (self);
#line 508 "../src/PlaybackManager.vala"
	_tmp55_ = self->player;
#line 508 "../src/PlaybackManager.vala"
	noise_playback_set_media (_tmp55_, _data10_->m);
#line 511 "../src/PlaybackManager.vala"
	_tmp56_ = self->priv->_playing;
#line 511 "../src/PlaybackManager.vala"
	if (!_tmp56_) {
#line 3613 "PlaybackManager.c"
		NoisePlayback* _tmp57_;
#line 512 "../src/PlaybackManager.vala"
		_tmp57_ = self->player;
#line 512 "../src/PlaybackManager.vala"
		noise_playback_pause (_tmp57_);
#line 3619 "PlaybackManager.c"
	}
#line 516 "../src/PlaybackManager.vala"
	_tmp59_ = noise_media_get_rowid (_data10_->m);
#line 516 "../src/PlaybackManager.vala"
	_tmp60_ = _tmp59_;
#line 516 "../src/PlaybackManager.vala"
	if (_tmp60_ >= ((gint64) 0)) {
#line 3627 "PlaybackManager.c"
		NoiseSettingsMain* _tmp61_;
		NoiseSettingsMain* _tmp62_;
#line 516 "../src/PlaybackManager.vala"
		_tmp61_ = noise_settings_main_get_default ();
#line 516 "../src/PlaybackManager.vala"
		_tmp62_ = _tmp61_;
#line 516 "../src/PlaybackManager.vala"
		_tmp58_ = !noise_settings_main_privacy_mode_enabled (_tmp62_);
#line 516 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp62_);
#line 3638 "PlaybackManager.c"
	} else {
#line 516 "../src/PlaybackManager.vala"
		_tmp58_ = FALSE;
#line 3642 "PlaybackManager.c"
	}
#line 516 "../src/PlaybackManager.vala"
	if (_tmp58_) {
#line 3646 "PlaybackManager.c"
		GSettings* _tmp63_;
		GSettings* _tmp64_;
		gint64 _tmp65_;
		gint64 _tmp66_;
#line 517 "../src/PlaybackManager.vala"
		_tmp63_ = noise_app_get_saved_state ();
#line 517 "../src/PlaybackManager.vala"
		_tmp64_ = _tmp63_;
#line 517 "../src/PlaybackManager.vala"
		_tmp65_ = noise_media_get_rowid (_data10_->m);
#line 517 "../src/PlaybackManager.vala"
		_tmp66_ = _tmp65_;
#line 517 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp64_, "last-media-playing", _tmp66_);
#line 3661 "PlaybackManager.c"
	}
#line 520 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 521 "../src/PlaybackManager.vala"
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
#line 3667 "PlaybackManager.c"
	}
#line 525 "../src/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda33__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 444 "../src/PlaybackManager.vala"
	block10_data_unref (_data10_);
#line 444 "../src/PlaybackManager.vala"
	_data10_ = NULL;
#line 3675 "PlaybackManager.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 3695 "PlaybackManager.c"
}


void
noise_playback_manager_change_gains_thread (NoisePlaybackManager* self)
{
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 543 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_equalizer_get_default ();
#line 544 "../src/PlaybackManager.vala"
	equalizer_settings = _tmp0_;
#line 545 "../src/PlaybackManager.vala"
	_tmp1_ = equalizer_settings;
#line 545 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
#line 545 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 545 "../src/PlaybackManager.vala"
	if (_tmp3_) {
#line 3721 "PlaybackManager.c"
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 546 "../src/PlaybackManager.vala"
		_tmp4_ = equalizer_settings;
#line 546 "../src/PlaybackManager.vala"
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
#line 546 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 546 "../src/PlaybackManager.vala"
		automatic_enabled = _tmp6_;
#line 547 "../src/PlaybackManager.vala"
		_tmp7_ = equalizer_settings;
#line 547 "../src/PlaybackManager.vala"
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
#line 547 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 547 "../src/PlaybackManager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 547 "../src/PlaybackManager.vala"
		selected_preset = _tmp10_;
#line 3749 "PlaybackManager.c"
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
#line 549 "../src/PlaybackManager.vala"
			_tmp11_ = equalizer_settings;
#line 549 "../src/PlaybackManager.vala"
			_tmp12_ = noise_settings_equalizer_get_presets (_tmp11_);
#line 549 "../src/PlaybackManager.vala"
			_tmp13_ = _tmp12_;
#line 549 "../src/PlaybackManager.vala"
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 549 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 549 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp13_);
#line 549 "../src/PlaybackManager.vala"
			_p_it = _tmp15_;
#line 549 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3773 "PlaybackManager.c"
				GeeIterator* _tmp16_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				NoiseEqualizerPreset* _tmp20_;
#line 549 "../src/PlaybackManager.vala"
				_tmp16_ = _p_it;
#line 549 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 549 "../src/PlaybackManager.vala"
					break;
#line 3786 "PlaybackManager.c"
				}
#line 549 "../src/PlaybackManager.vala"
				_tmp17_ = _p_it;
#line 549 "../src/PlaybackManager.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 549 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp18_;
#line 550 "../src/PlaybackManager.vala"
				_tmp20_ = p;
#line 550 "../src/PlaybackManager.vala"
				if (_tmp20_ != NULL) {
#line 3798 "PlaybackManager.c"
					NoiseMedia* _tmp21_;
#line 550 "../src/PlaybackManager.vala"
					_tmp21_ = self->priv->_current_media;
#line 550 "../src/PlaybackManager.vala"
					_tmp19_ = _tmp21_ != NULL;
#line 3804 "PlaybackManager.c"
				} else {
#line 550 "../src/PlaybackManager.vala"
					_tmp19_ = FALSE;
#line 3808 "PlaybackManager.c"
				}
#line 550 "../src/PlaybackManager.vala"
				if (_tmp19_) {
#line 3812 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					gboolean _tmp37_;
#line 551 "../src/PlaybackManager.vala"
					_tmp22_ = p;
#line 551 "../src/PlaybackManager.vala"
					_tmp23_ = noise_equalizer_preset_get_name (_tmp22_);
#line 551 "../src/PlaybackManager.vala"
					_tmp24_ = _tmp23_;
#line 551 "../src/PlaybackManager.vala"
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 551 "../src/PlaybackManager.vala"
					preset_name = _tmp25_;
#line 552 "../src/PlaybackManager.vala"
					_tmp26_ = self->priv->_current_media;
#line 552 "../src/PlaybackManager.vala"
					_tmp27_ = noise_media_get_genre (_tmp26_);
#line 552 "../src/PlaybackManager.vala"
					_tmp28_ = _tmp27_;
#line 552 "../src/PlaybackManager.vala"
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
#line 552 "../src/PlaybackManager.vala"
					media_genre = _tmp29_;
#line 554 "../src/PlaybackManager.vala"
					_tmp31_ = media_genre;
#line 554 "../src/PlaybackManager.vala"
					_tmp32_ = preset_name;
#line 554 "../src/PlaybackManager.vala"
					if (string_contains (_tmp31_, _tmp32_)) {
#line 554 "../src/PlaybackManager.vala"
						_tmp30_ = TRUE;
#line 3858 "PlaybackManager.c"
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
#line 554 "../src/PlaybackManager.vala"
						_tmp33_ = preset_name;
#line 554 "../src/PlaybackManager.vala"
						_tmp34_ = media_genre;
#line 554 "../src/PlaybackManager.vala"
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
#line 3868 "PlaybackManager.c"
					}
#line 554 "../src/PlaybackManager.vala"
					match_genre = _tmp30_;
#line 556 "../src/PlaybackManager.vala"
					_tmp37_ = automatic_enabled;
#line 556 "../src/PlaybackManager.vala"
					if (_tmp37_) {
#line 3876 "PlaybackManager.c"
						gboolean _tmp38_;
#line 556 "../src/PlaybackManager.vala"
						_tmp38_ = match_genre;
#line 556 "../src/PlaybackManager.vala"
						_tmp36_ = _tmp38_;
#line 3882 "PlaybackManager.c"
					} else {
#line 556 "../src/PlaybackManager.vala"
						_tmp36_ = FALSE;
#line 3886 "PlaybackManager.c"
					}
#line 556 "../src/PlaybackManager.vala"
					if (_tmp36_) {
#line 556 "../src/PlaybackManager.vala"
						_tmp35_ = TRUE;
#line 3892 "PlaybackManager.c"
					} else {
						gboolean _tmp39_ = FALSE;
						gboolean _tmp40_;
#line 557 "../src/PlaybackManager.vala"
						_tmp40_ = automatic_enabled;
#line 557 "../src/PlaybackManager.vala"
						if (!_tmp40_) {
#line 3900 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp41_;
							const gchar* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
#line 557 "../src/PlaybackManager.vala"
							_tmp41_ = p;
#line 557 "../src/PlaybackManager.vala"
							_tmp42_ = noise_equalizer_preset_get_name (_tmp41_);
#line 557 "../src/PlaybackManager.vala"
							_tmp43_ = _tmp42_;
#line 557 "../src/PlaybackManager.vala"
							_tmp44_ = selected_preset;
#line 557 "../src/PlaybackManager.vala"
							_tmp39_ = g_strcmp0 (_tmp43_, _tmp44_) == 0;
#line 3915 "PlaybackManager.c"
						} else {
#line 557 "../src/PlaybackManager.vala"
							_tmp39_ = FALSE;
#line 3919 "PlaybackManager.c"
						}
#line 557 "../src/PlaybackManager.vala"
						_tmp35_ = _tmp39_;
#line 3923 "PlaybackManager.c"
					}
#line 556 "../src/PlaybackManager.vala"
					if (_tmp35_) {
#line 3927 "PlaybackManager.c"
						{
							gint i = 0;
#line 558 "../src/PlaybackManager.vala"
							i = 0;
#line 3932 "PlaybackManager.c"
							{
								gboolean _tmp45_ = FALSE;
#line 558 "../src/PlaybackManager.vala"
								_tmp45_ = TRUE;
#line 558 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 3939 "PlaybackManager.c"
									gint _tmp47_;
									NoisePlayback* _tmp48_;
									gint _tmp49_;
									NoiseEqualizerPreset* _tmp50_;
									gint _tmp51_;
#line 558 "../src/PlaybackManager.vala"
									if (!_tmp45_) {
#line 3947 "PlaybackManager.c"
										gint _tmp46_;
#line 558 "../src/PlaybackManager.vala"
										_tmp46_ = i;
#line 558 "../src/PlaybackManager.vala"
										i = _tmp46_ + 1;
#line 3953 "PlaybackManager.c"
									}
#line 558 "../src/PlaybackManager.vala"
									_tmp45_ = FALSE;
#line 558 "../src/PlaybackManager.vala"
									_tmp47_ = i;
#line 558 "../src/PlaybackManager.vala"
									if (!(_tmp47_ < 10)) {
#line 558 "../src/PlaybackManager.vala"
										break;
#line 3963 "PlaybackManager.c"
									}
#line 559 "../src/PlaybackManager.vala"
									_tmp48_ = self->player;
#line 559 "../src/PlaybackManager.vala"
									_tmp49_ = i;
#line 559 "../src/PlaybackManager.vala"
									_tmp50_ = p;
#line 559 "../src/PlaybackManager.vala"
									_tmp51_ = i;
#line 559 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp48_, _tmp49_, noise_equalizer_preset_get_gain (_tmp50_, _tmp51_));
#line 3975 "PlaybackManager.c"
								}
							}
						}
#line 562 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 562 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 562 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 562 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 562 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 562 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 562 "../src/PlaybackManager.vala"
						return;
#line 3993 "PlaybackManager.c"
					}
#line 550 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 550 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 3999 "PlaybackManager.c"
				}
#line 549 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 4003 "PlaybackManager.c"
			}
#line 549 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 4007 "PlaybackManager.c"
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp52_;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
			GeeIterator* _tmp55_;
#line 567 "../src/PlaybackManager.vala"
			_tmp52_ = noise_equalizer_get_default_presets ();
#line 567 "../src/PlaybackManager.vala"
			_tmp53_ = _tmp52_;
#line 567 "../src/PlaybackManager.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 567 "../src/PlaybackManager.vala"
			_tmp55_ = _tmp54_;
#line 567 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp53_);
#line 567 "../src/PlaybackManager.vala"
			_p_it = _tmp55_;
#line 567 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 4029 "PlaybackManager.c"
				GeeIterator* _tmp56_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp57_;
				gpointer _tmp58_;
				gboolean _tmp59_ = FALSE;
				NoiseEqualizerPreset* _tmp60_;
#line 567 "../src/PlaybackManager.vala"
				_tmp56_ = _p_it;
#line 567 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp56_)) {
#line 567 "../src/PlaybackManager.vala"
					break;
#line 4042 "PlaybackManager.c"
				}
#line 567 "../src/PlaybackManager.vala"
				_tmp57_ = _p_it;
#line 567 "../src/PlaybackManager.vala"
				_tmp58_ = gee_iterator_get (_tmp57_);
#line 567 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp58_;
#line 568 "../src/PlaybackManager.vala"
				_tmp60_ = p;
#line 568 "../src/PlaybackManager.vala"
				if (_tmp60_ != NULL) {
#line 4054 "PlaybackManager.c"
					NoiseMedia* _tmp61_;
#line 568 "../src/PlaybackManager.vala"
					_tmp61_ = self->priv->_current_media;
#line 568 "../src/PlaybackManager.vala"
					_tmp59_ = _tmp61_ != NULL;
#line 4060 "PlaybackManager.c"
				} else {
#line 568 "../src/PlaybackManager.vala"
					_tmp59_ = FALSE;
#line 4064 "PlaybackManager.c"
				}
#line 568 "../src/PlaybackManager.vala"
				if (_tmp59_) {
#line 4068 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp62_;
					const gchar* _tmp63_;
					const gchar* _tmp64_;
					gchar* _tmp65_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gboolean _tmp70_ = FALSE;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					gboolean match_genre = FALSE;
					gboolean _tmp75_ = FALSE;
					gboolean _tmp76_ = FALSE;
					gboolean _tmp77_;
#line 569 "../src/PlaybackManager.vala"
					_tmp62_ = p;
#line 569 "../src/PlaybackManager.vala"
					_tmp63_ = noise_equalizer_preset_get_name (_tmp62_);
#line 569 "../src/PlaybackManager.vala"
					_tmp64_ = _tmp63_;
#line 569 "../src/PlaybackManager.vala"
					_tmp65_ = g_utf8_strdown (_tmp64_, (gssize) -1);
#line 569 "../src/PlaybackManager.vala"
					preset_name = _tmp65_;
#line 570 "../src/PlaybackManager.vala"
					_tmp66_ = self->priv->_current_media;
#line 570 "../src/PlaybackManager.vala"
					_tmp67_ = noise_media_get_genre (_tmp66_);
#line 570 "../src/PlaybackManager.vala"
					_tmp68_ = _tmp67_;
#line 570 "../src/PlaybackManager.vala"
					_tmp69_ = g_utf8_strdown (_tmp68_, (gssize) -1);
#line 570 "../src/PlaybackManager.vala"
					media_genre = _tmp69_;
#line 572 "../src/PlaybackManager.vala"
					_tmp71_ = media_genre;
#line 572 "../src/PlaybackManager.vala"
					_tmp72_ = preset_name;
#line 572 "../src/PlaybackManager.vala"
					if (string_contains (_tmp71_, _tmp72_)) {
#line 572 "../src/PlaybackManager.vala"
						_tmp70_ = TRUE;
#line 4114 "PlaybackManager.c"
					} else {
						const gchar* _tmp73_;
						const gchar* _tmp74_;
#line 572 "../src/PlaybackManager.vala"
						_tmp73_ = preset_name;
#line 572 "../src/PlaybackManager.vala"
						_tmp74_ = media_genre;
#line 572 "../src/PlaybackManager.vala"
						_tmp70_ = string_contains (_tmp73_, _tmp74_);
#line 4124 "PlaybackManager.c"
					}
#line 572 "../src/PlaybackManager.vala"
					match_genre = _tmp70_;
#line 574 "../src/PlaybackManager.vala"
					_tmp77_ = automatic_enabled;
#line 574 "../src/PlaybackManager.vala"
					if (_tmp77_) {
#line 4132 "PlaybackManager.c"
						gboolean _tmp78_;
#line 574 "../src/PlaybackManager.vala"
						_tmp78_ = match_genre;
#line 574 "../src/PlaybackManager.vala"
						_tmp76_ = _tmp78_;
#line 4138 "PlaybackManager.c"
					} else {
#line 574 "../src/PlaybackManager.vala"
						_tmp76_ = FALSE;
#line 4142 "PlaybackManager.c"
					}
#line 574 "../src/PlaybackManager.vala"
					if (_tmp76_) {
#line 574 "../src/PlaybackManager.vala"
						_tmp75_ = TRUE;
#line 4148 "PlaybackManager.c"
					} else {
						gboolean _tmp79_ = FALSE;
						gboolean _tmp80_;
#line 575 "../src/PlaybackManager.vala"
						_tmp80_ = automatic_enabled;
#line 575 "../src/PlaybackManager.vala"
						if (!_tmp80_) {
#line 4156 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp81_;
							const gchar* _tmp82_;
							const gchar* _tmp83_;
							const gchar* _tmp84_;
#line 575 "../src/PlaybackManager.vala"
							_tmp81_ = p;
#line 575 "../src/PlaybackManager.vala"
							_tmp82_ = noise_equalizer_preset_get_name (_tmp81_);
#line 575 "../src/PlaybackManager.vala"
							_tmp83_ = _tmp82_;
#line 575 "../src/PlaybackManager.vala"
							_tmp84_ = selected_preset;
#line 575 "../src/PlaybackManager.vala"
							_tmp79_ = g_strcmp0 (_tmp83_, _tmp84_) == 0;
#line 4171 "PlaybackManager.c"
						} else {
#line 575 "../src/PlaybackManager.vala"
							_tmp79_ = FALSE;
#line 4175 "PlaybackManager.c"
						}
#line 575 "../src/PlaybackManager.vala"
						_tmp75_ = _tmp79_;
#line 4179 "PlaybackManager.c"
					}
#line 574 "../src/PlaybackManager.vala"
					if (_tmp75_) {
#line 4183 "PlaybackManager.c"
						{
							gint i = 0;
#line 576 "../src/PlaybackManager.vala"
							i = 0;
#line 4188 "PlaybackManager.c"
							{
								gboolean _tmp85_ = FALSE;
#line 576 "../src/PlaybackManager.vala"
								_tmp85_ = TRUE;
#line 576 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 4195 "PlaybackManager.c"
									gint _tmp87_;
									NoisePlayback* _tmp88_;
									gint _tmp89_;
									NoiseEqualizerPreset* _tmp90_;
									gint _tmp91_;
#line 576 "../src/PlaybackManager.vala"
									if (!_tmp85_) {
#line 4203 "PlaybackManager.c"
										gint _tmp86_;
#line 576 "../src/PlaybackManager.vala"
										_tmp86_ = i;
#line 576 "../src/PlaybackManager.vala"
										i = _tmp86_ + 1;
#line 4209 "PlaybackManager.c"
									}
#line 576 "../src/PlaybackManager.vala"
									_tmp85_ = FALSE;
#line 576 "../src/PlaybackManager.vala"
									_tmp87_ = i;
#line 576 "../src/PlaybackManager.vala"
									if (!(_tmp87_ < 10)) {
#line 576 "../src/PlaybackManager.vala"
										break;
#line 4219 "PlaybackManager.c"
									}
#line 577 "../src/PlaybackManager.vala"
									_tmp88_ = self->player;
#line 577 "../src/PlaybackManager.vala"
									_tmp89_ = i;
#line 577 "../src/PlaybackManager.vala"
									_tmp90_ = p;
#line 577 "../src/PlaybackManager.vala"
									_tmp91_ = i;
#line 577 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp88_, _tmp89_, noise_equalizer_preset_get_gain (_tmp90_, _tmp91_));
#line 4231 "PlaybackManager.c"
								}
							}
						}
#line 580 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 580 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 580 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 580 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 580 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 580 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 580 "../src/PlaybackManager.vala"
						return;
#line 4249 "PlaybackManager.c"
					}
#line 568 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 568 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 4255 "PlaybackManager.c"
				}
#line 567 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 4259 "PlaybackManager.c"
			}
#line 567 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 4263 "PlaybackManager.c"
		}
#line 545 "../src/PlaybackManager.vala"
		_g_free0 (selected_preset);
#line 4267 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 586 "../src/PlaybackManager.vala"
		i = 0;
#line 4273 "PlaybackManager.c"
		{
			gboolean _tmp92_ = FALSE;
#line 586 "../src/PlaybackManager.vala"
			_tmp92_ = TRUE;
#line 586 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 4280 "PlaybackManager.c"
				gint _tmp94_;
				NoisePlayback* _tmp95_;
				gint _tmp96_;
#line 586 "../src/PlaybackManager.vala"
				if (!_tmp92_) {
#line 4286 "PlaybackManager.c"
					gint _tmp93_;
#line 586 "../src/PlaybackManager.vala"
					_tmp93_ = i;
#line 586 "../src/PlaybackManager.vala"
					i = _tmp93_ + 1;
#line 4292 "PlaybackManager.c"
				}
#line 586 "../src/PlaybackManager.vala"
				_tmp92_ = FALSE;
#line 586 "../src/PlaybackManager.vala"
				_tmp94_ = i;
#line 586 "../src/PlaybackManager.vala"
				if (!(_tmp94_ < 10)) {
#line 586 "../src/PlaybackManager.vala"
					break;
#line 4302 "PlaybackManager.c"
				}
#line 587 "../src/PlaybackManager.vala"
				_tmp95_ = self->player;
#line 587 "../src/PlaybackManager.vala"
				_tmp96_ = i;
#line 587 "../src/PlaybackManager.vala"
				noise_playback_set_equalizer_gain (_tmp95_, _tmp96_, 0);
#line 4310 "PlaybackManager.c"
			}
		}
	}
#line 543 "../src/PlaybackManager.vala"
	_g_object_unref0 (equalizer_settings);
#line 4316 "PlaybackManager.c"
}


void
noise_playback_manager_stop_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
	gint64 _tmp10_;
#line 591 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 592 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 593 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 595 "../src/PlaybackManager.vala"
	was_playing = (gint64) 0;
#line 596 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 596 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 4344 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 597 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 597 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 597 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 597 "../src/PlaybackManager.vala"
		was_playing = _tmp4_;
#line 4356 "PlaybackManager.c"
	}
#line 600 "../src/PlaybackManager.vala"
	_tmp5_ = noise_settings_main_get_default ();
#line 600 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 600 "../src/PlaybackManager.vala"
	_tmp7_ = !noise_settings_main_privacy_mode_enabled (_tmp6_);
#line 600 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp6_);
#line 600 "../src/PlaybackManager.vala"
	if (_tmp7_) {
#line 4368 "PlaybackManager.c"
		GSettings* _tmp8_;
		GSettings* _tmp9_;
#line 601 "../src/PlaybackManager.vala"
		_tmp8_ = noise_app_get_saved_state ();
#line 601 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 601 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
#line 4377 "PlaybackManager.c"
	}
#line 603 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, NULL);
#line 605 "../src/PlaybackManager.vala"
	_tmp10_ = was_playing;
#line 605 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, _tmp10_);
#line 4385 "PlaybackManager.c"
}


static GVariant*
_variant_new4 (gboolean value)
{
#line 611 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4394 "PlaybackManager.c"
}


void
noise_playback_manager_start_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 608 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 609 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 609 "../src/PlaybackManager.vala"
	noise_playback_play (_tmp0_);
#line 610 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, TRUE);
#line 611 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 611 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 611 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 611 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 611 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 611 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new4 (TRUE);
#line 611 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 611 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 612 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
#line 4434 "PlaybackManager.c"
}


static GVariant*
_variant_new5 (gboolean value)
{
#line 618 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4443 "PlaybackManager.c"
}


void
noise_playback_manager_pause_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 615 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 616 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 616 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 617 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 618 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 618 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 618 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 618 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 618 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 618 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new5 (FALSE);
#line 618 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 618 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 619 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
#line 4483 "PlaybackManager.c"
}


NoisePlaybackManager*
noise_playback_manager_construct (GType object_type)
{
	NoisePlaybackManager * self = NULL;
#line 35 "../src/PlaybackManager.vala"
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
#line 35 "../src/PlaybackManager.vala"
	return self;
#line 4495 "PlaybackManager.c"
}


NoisePlaybackManager*
noise_playback_manager_new (void)
{
#line 35 "../src/PlaybackManager.vala"
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
#line 4504 "PlaybackManager.c"
}


static NoiseLibrary*
noise_playback_manager_get_library (NoisePlaybackManager* self)
{
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/PlaybackManager.vala"
	_tmp0_ = noise_libraries_manager;
#line 60 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_->local_library;
#line 60 "../src/PlaybackManager.vala"
	result = _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	return result;
#line 4524 "PlaybackManager.c"
}


gint
noise_playback_manager_get_current_index (NoisePlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 64 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 65 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 65 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 4545 "PlaybackManager.c"
		gint _tmp3_;
#line 66 "../src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_index;
#line 66 "../src/PlaybackManager.vala"
		result = _tmp3_;
#line 66 "../src/PlaybackManager.vala"
		return result;
#line 4553 "PlaybackManager.c"
	} else {
		gint _tmp4_;
#line 68 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled_index;
#line 68 "../src/PlaybackManager.vala"
		result = _tmp4_;
#line 68 "../src/PlaybackManager.vala"
		return result;
#line 4562 "PlaybackManager.c"
	}
}


void
noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 71 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:72: Current index: %d", value);
#line 73 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 73 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 73 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 74 "../src/PlaybackManager.vala"
		self->priv->_current_index = value;
#line 4588 "PlaybackManager.c"
	} else {
#line 76 "../src/PlaybackManager.vala"
		self->priv->_current_shuffled_index = value;
#line 4592 "PlaybackManager.c"
	}
#line 71 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
#line 4596 "PlaybackManager.c"
}


gboolean
noise_playback_manager_get_playing (NoisePlaybackManager* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 83 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_playing;
#line 83 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 83 "../src/PlaybackManager.vala"
	return result;
#line 4613 "PlaybackManager.c"
}


static void
noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                    gboolean value)
{
#line 83 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_playing (self) != value) {
#line 83 "../src/PlaybackManager.vala"
		self->priv->_playing = value;
#line 83 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
#line 4629 "PlaybackManager.c"
	}
}


gdouble
noise_playback_manager_get_volume (NoisePlaybackManager* self)
{
	gdouble result;
	NoisePlayback* _tmp0_;
#line 87 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 88 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 88 "../src/PlaybackManager.vala"
	result = noise_playback_get_volume (_tmp0_);
#line 88 "../src/PlaybackManager.vala"
	return result;
#line 4647 "PlaybackManager.c"
}


void
noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                   gdouble value)
{
	NoisePlayback* _tmp0_;
#line 90 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/PlaybackManager.vala"
	self->priv->saved_volume = value;
#line 92 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 92 "../src/PlaybackManager.vala"
	noise_playback_set_volume (_tmp0_, value);
#line 90 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
#line 4666 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_current_media (NoisePlaybackManager* self)
{
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_media;
#line 100 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	return result;
#line 4683 "PlaybackManager.c"
}


static void
noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                          NoiseMedia* value)
{
#line 100 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_current_media (self) != value) {
#line 4695 "PlaybackManager.c"
		NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 100 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_media);
#line 100 "../src/PlaybackManager.vala"
		self->priv->_current_media = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
#line 4705 "PlaybackManager.c"
	}
}


static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 35 "../src/PlaybackManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 35 "../src/PlaybackManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 35 "../src/PlaybackManager.vala"
		data1 = closure->data;
#line 35 "../src/PlaybackManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 4732 "PlaybackManager.c"
	} else {
#line 35 "../src/PlaybackManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 35 "../src/PlaybackManager.vala"
		data2 = closure->data;
#line 4738 "PlaybackManager.c"
	}
#line 35 "../src/PlaybackManager.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 35 "../src/PlaybackManager.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 4744 "PlaybackManager.c"
}


static GObject *
noise_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	NoiseStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	NoiseStreamer* _tmp10_;
	NoiseStreamer* _tmp11_;
	NoisePlayback* _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
#line 102 "../src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 102 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 103 "../src/PlaybackManager.vala"
	_tmp0_ = noise_history_playlist_new ();
#line 103 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 103 "../src/PlaybackManager.vala"
	self->history_playlist = _tmp0_;
#line 104 "../src/PlaybackManager.vala"
	_tmp1_ = noise_static_playlist_new ();
#line 104 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 104 "../src/PlaybackManager.vala"
	self->queue_playlist = _tmp1_;
#line 105 "../src/PlaybackManager.vala"
	_tmp2_ = self->queue_playlist;
#line 105 "../src/PlaybackManager.vala"
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
#line 106 "../src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 106 "../src/PlaybackManager.vala"
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
#line 107 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 107 "../src/PlaybackManager.vala"
	noise_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
#line 108 "../src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 108 "../src/PlaybackManager.vala"
	noise_static_playlist_set_show_badge (_tmp5_, TRUE);
#line 109 "../src/PlaybackManager.vala"
	_tmp6_ = self->queue_playlist;
#line 109 "../src/PlaybackManager.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 109 "../src/PlaybackManager.vala"
	_g_object_unref0 (((NoisePlaylist*) _tmp6_)->icon);
#line 109 "../src/PlaybackManager.vala"
	((NoisePlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
#line 111 "../src/PlaybackManager.vala"
	_tmp8_ = noise_streamer_new ();
#line 111 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 111 "../src/PlaybackManager.vala"
	self->file_player = _tmp8_;
#line 112 "../src/PlaybackManager.vala"
	_tmp9_ = self->priv->playbacks;
#line 112 "../src/PlaybackManager.vala"
	_tmp10_ = self->file_player;
#line 112 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (NoisePlayback*) _tmp10_);
#line 113 "../src/PlaybackManager.vala"
	_tmp11_ = self->file_player;
#line 113 "../src/PlaybackManager.vala"
	_tmp12_ = _g_object_ref0 ((NoisePlayback*) _tmp11_);
#line 113 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 113 "../src/PlaybackManager.vala"
	self->player = _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	return obj;
#line 4833 "PlaybackManager.c"
}


static void
noise_playback_manager_class_init (NoisePlaybackManagerClass * klass)
{
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &NoisePlaybackManager_private_offset);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback-paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4874 "PlaybackManager.c"
}


static void
noise_playback_manager_instance_init (NoisePlaybackManager * self)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 35 "../src/PlaybackManager.vala"
	self->priv = noise_playback_manager_get_instance_private (self);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_init (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/PlaybackManager.vala"
	self->priv->playbacks = _tmp0_;
#line 51 "../src/PlaybackManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "../src/PlaybackManager.vala"
	self->priv->_current = _tmp1_;
#line 54 "../src/PlaybackManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled = _tmp2_;
#line 83 "../src/PlaybackManager.vala"
	self->priv->_playing = FALSE;
#line 85 "../src/PlaybackManager.vala"
	self->priv->saved_volume = (gdouble) 1;
#line 4904 "PlaybackManager.c"
}


static void
noise_playback_manager_finalize (GObject * obj)
{
	NoisePlaybackManager * self;
#line 35 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbacks);
#line 51 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current);
#line 54 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_shuffled);
#line 56 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 57 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 98 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 99 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 100 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_media);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
#line 4934 "PlaybackManager.c"
}


/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Noise.Playback} to play a media
*/
GType
noise_playback_manager_get_type (void)
{
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		NoisePlaybackManager_private_offset = g_type_add_instance_private (noise_playback_manager_type_id, sizeof (NoisePlaybackManagerPrivate));
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}


static void
_vala_noise_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_double (value, noise_playback_manager_get_volume (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4992 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4998 "PlaybackManager.c"
	}
}


static void
_vala_noise_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_volume (self, g_value_get_double (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 5037 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 5043 "PlaybackManager.c"
	}
}



